/*
Copyright 2002 - 2004 UnitedAdmins
Project originally created by OLO (http://olo.counter-strike.pl)

This file is part of StatsMe.

   StatsMe is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   StatsMe is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with StatsMe; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   A copy of the GNU General Public License is available in a file called COPYING.
   See README for more information.

*/

/* $Id: statsme.h,v 1.49 2004/04/13 13:19:53 punisher Exp $ */

#ifndef STATSME_H
#define STATSME_H

#include <time.h>			// time()
#include <enginecallback.h>		// ALERT()
#include <sdk_util.h>			// UTIL_VarArgs()
#include <api_info.h>
#include "vers_plugin.h"

enum MOD_TYPE
{
	MOD_UNKNOW = 0,
		MOD_CSTRIKE,
		MOD_DOD,
		MOD_TFC,
		MOD_FLF,
		MOD_DMC,
		MOD_VS,
		MOD_FIREARMS,
		MOD_ACTION,
		MOD_VALVE,
		MOD_GEARBOX,
		MOD_RICOCHET,
		MOD_NS,
		MOD_NSP, // <- NS 3.0 beta, probably temporary modname
		MOD_IOS,
		MOD_DCRISIS
};

struct mod_settings_t
{
	bool vgui2;
};


// Some calculations for stats
#define ACCURACY_FORMULA(a,b) ((a) ? ( ((float)b * 100.00) / (float)a ) : 0.00 )// a - shots, b - hits
#define EFFEC_FORMULA(a,b) ((b + a) ? ( ((float)a * 100.00) / (float)( b + a ) ) : 0.00 )// a - kills, b - deaths

// Parts of body for hits
#define HITGROUP_GENERIC	0 // none
#define HITGROUP_HEAD		1
#define HITGROUP_CHEST		2
#define HITGROUP_STOMACH	3
#define HITGROUP_LEFTARM	4
#define HITGROUP_RIGHTARM	5
#define HITGROUP_LEFTLEG	6
#define HITGROUP_RIGHTLEG	7

#define DEBUG_OPTION // allows to use sm_debug cvar in game
#define ADDON_LAYOUT // define if you want to have new structure of folders and logging

#define ROUND_VALUE(a) (a-(int)a)

#ifndef GETPLAYERAUTHID
#define GETPLAYERAUTHID	(*g_engfuncs.pfnGetPlayerAuthId)
#endif
#ifndef GETPLAYERWONID
#define GETPLAYERWONID	(*g_engfuncs.pfnGetPlayerWONId)
#endif
#define CLIENT_PRINTF (*g_engfuncs.pfnClientPrintf)
#define GET_PLAYER_POINTER(e) &players[ENTINDEX(e)]
#define GET_PLAYER_POINTER_I(i) &players[i]

#define PARSE_WRITE_BYTE	PARSE_INTEGER
#define PARSE_WRITE_CHAR	PARSE_INTEGER
#define PARSE_WRITE_SHORT	PARSE_INTEGER
#define PARSE_WRITE_LONG	PARSE_INTEGER
#define PARSE_WRITE_ENTITY	PARSE_INTEGER
#define PARSE_WRITE_ANGLE	PARSE_FLOAT
#define PARSE_WRITE_COORD	PARSE_FLOAT
#define PARSE_WRITE_STRING	PARSE_STRING

#define MAX_PARSE_VALUES 24
#define MAX_SM_REG_MSGS		288 // MAX_REG_MSGS is 256

#define SM_DEATHMSG			256 //SM_DeathMsg
#define SM_ROUNDEND			257 //SM_RoundEnd
#define SM_ROUNDSTART		258 //SM_RoundStart
#define SM_MONSTERKILL		259 //SM_MonsterKill
#define SM_C4TIMER			260 //SM_C4Timer
#define SM_DAMAGE			261 //SM_Damage
#define SM_INFOCHANGED		262 //SM_InfoChanged
#define SM_CONNECT			263 //SM_Connect
#define SM_DISCONNECT		264 //SM_Disconnect
#define SM_PUTINSERVER		265 //SM_PutInServer
#define SM_MAPSTART			266	//SM_MapStart
#define SM_LASTMAN			267 //SM_Lastman
#define SM_FREEZETIMESTART  268 //SM_FreezetimeStart
#define SM_FREEZETIMEEND	269 //SM_FreezetimeEnd
#define SM_BUYTIMESTART		270 //SM_BuytimeStart
#define SM_BUYTIMEEND		271	//SM_BuytimeEnd


// Weapon Definitions

// Counter-Strike

#define WEAPON_CS_NONE			0
#define WEAPON_CS_P228			1 // 
#define WEAPON_CS_DUMMY			2 // 
#define WEAPON_CS_SCOUT			3
#define WEAPON_CS_HEGRENADE		4
#define WEAPON_CS_XM1014		5
#define WEAPON_CS_C4			6
#define WEAPON_CS_MAC10			7
#define WEAPON_CS_AUG			8
#define WEAPON_CS_SMOKEGRENADE	9
#define WEAPON_CS_ELITE			10
#define WEAPON_CS_FIVESEVEN		11
#define WEAPON_CS_UMP45			12
#define WEAPON_CS_SG550			13
#define WEAPON_CS_GALIL			14
#define WEAPON_CS_FAMAS			15
#define WEAPON_CS_USP			16
#define WEAPON_CS_GLOCK18		17
#define WEAPON_CS_AWP			18
#define WEAPON_CS_MP5NAVY		19
#define WEAPON_CS_M249			20
#define WEAPON_CS_M3			21
#define WEAPON_CS_M4A1			22
#define WEAPON_CS_TMP			23
#define WEAPON_CS_G3SG1			24
#define WEAPON_CS_FLASHBANG		25
#define WEAPON_CS_DEAGLE		26
#define WEAPON_CS_SG552			27
#define WEAPON_CS_AK47			28
#define WEAPON_CS_KNIFE			29
#define WEAPON_CS_P90			30

#define WEAPON_DOD_NONE				0
#define WEAPON_DOD_AMERKNIFE		1
#define WEAPON_DOD_GERKNIFE			2
#define WEAPON_DOD_COLT				3
#define WEAPON_DOD_LUGER			4
#define WEAPON_DOD_GARAND			5
#define WEAPON_DOD_SCOPEDKAR		6
#define	WEAPON_DOD_THOMPSON			7
#define WEAPON_DOD_MP44				8
#define WEAPON_DOD_SPRING			9
#define WEAPON_DOD_KAR				10
#define WEAPON_DOD_BAR				11
#define WEAPON_DOD_MP40				12
#define WEAPON_DOD_HANDGRENADE      13
#define WEAPON_DOD_STICKGRENADE     14
#define WEAPON_DOD_STICKGRENADE_EX  15
#define WEAPON_DOD_HANDGRENADE_EX	16
#define WEAPON_DOD_MG42				17
#define WEAPON_DOD_30CAL			18
#define WEAPON_DOD_SPADE			19
#define WEAPON_DOD_M1CARBINE	    20
#define WEAPON_DOD_MG34				21
#define WEAPON_DOD_GREASEGUN		22
#define WEAPON_DOD_FG42				23
#define WEAPON_DOD_K43				24
#define WEAPON_DOD_ENFIELD			25
#define WEAPON_DOD_STEN				26
#define WEAPON_DOD_BREN				27
#define WEAPON_DOD_WEBLEY			28
#define WEAPON_DOD_BAZOOKA			29
#define WEAPON_DOD_PSCHRECK			30
#define WEAPON_DOD_PIAT				31


enum { // menu ids
	MENU_IDLE,
	STATS_MENU,
	SETTINGS_MENU,
	CUSTOM_MENU
};

enum { // types of data from events (engine msgs)
	V_FLOAT,
	V_INTEGER ,
	V_STRING 
};

// keeps values from engine messages
struct msg_vault_t {
	float fValue;
	int	iValue;
	const char* sValue;
	int	type;
};

// struct to keep values from SM scripting {%.myvar}
struct myvar_t {
	char* name;
	char* string;
	int	len;
	double value;
	myvar_t* next;
};

// tasks
struct task_t {
	char* cmd;
	float root_time;
	float time;
	int flags;
	task_t* next;
	task_t* prev;
};

// conditions for sm_register
struct cond_t {
	char* sValue;
	int	len;
	float fValue;
	int	iValue;
	int	type;			// =, <, >, & or !
	cond_t* next;
};

// filled during weaponlist engine message
struct wpn_sel_t {
	short int iId;			// the weapon id value
	char name[32];			// name of the weapon when selecting it
};

struct fun_t {
	void (*function)(void*);
};

// keeps motd for players 	 
struct motd_t { 	 
	char* msg; 	 
	motd_t*next; 	 
};

// menu and aliases
struct action_t {
	char* name;
	char* cmd;
	int flags;
	action_t* next;
};

struct engtask_t {
	char* cmd;
	int flag;
	int id;
	bool done;
	engtask_t* next;
};

// sm_register
struct fun_call_t {
	char* cmd;			// commnad to execute
	bool player;		// receiver is a specified player
	bool world;			// receiver is a world ( index = 0 )
	bool once;			// allow/prohibit to call multpile times (f.e. the same event sent to different players)
	bool done;			// does this func has been already excetued and can't be called again?
	bool fillme;		// does it should be filled with extra info ( { x ? y : z } and so on )?
	bool whole;			// text in condition must exactly match
	bool dead;			// send only if player is dead
	bool alive;			// send only if player is alive
	int mode;			// keeps info on what sm_mode the flags are stored
	int len;			// length of this command
	int where;			// diffrences from 64 (my internal usage)
	int quotes;			// does this call uses quotes
	int	 flag;			// to check with sm_mode, if not set in sm_mode then event is not called
	float stamp;		// save when this call has been executed (for 'once' boolean)
	cond_t* cond[MAX_PARSE_VALUES];	// list of conditions (filter)
	fun_call_t*next;
};

// stats - used by different structures to store some data
struct stat_t {
	char name[32];
	char authid[38];
	const char* text;
	int	id;
	int	shots;
	int	hits;
	int	hitgroup[10];
	int	damage;
	int	kills;
	int	hs;
	int	tks;
	int	deaths;
	int sk;
	int	clip;
	int	ammo;
	int	score;
	int flags;
	float eff;
	float acc;
	float points;
	float dist;
	int playtime;
	int pstatsRank;
	int pstatsKills;
	int pstatsDeaths;
	float pstatsKPD;
	float pstatsKPM;
	int pstatsPoints;
	int userdefined[20];

	stat_t* custom;
	stat_t* next;
	stat_t* prev;
};

class player_t {
public:
	edict_t*	pEdict;
	char		ip[32];
	char		name[32];
	int			index;
	bool		bot;
	bool		ingame;
	float		play_time;

	char		class_name[32];
	int			class_index;

	char		team_name[32];
	int			team_index;

	float		monster_time;			// duration
	stat_t		aMon_stats;				// monster kill stats
	stat_t		aGm_stats;
	stat_t		aRnd_stats;
	stat_t		aPpl_stats[33];			// stats that keeps attacked players (round stats)
	stat_t		aWpn_stats[MAX_WEAPONS];// game weapon stats

	stat_t*		pMon_stats;
	stat_t*		pGm_stats;
	stat_t*		pRnd_stats;
	stat_t*		pPpl_stats;
	stat_t*		pWpn_stats;

	stat_t*		pRank;					// position in rank (top15)

	stat_t*		custom;					// internal usage
	stat_t*		weapon;					// stats of currently used weapon
	int			aiming_at;				// on what part of body the player is aming - chest, head, stomach etc.

	player_t*	killer;
	player_t*	victim;

	int			health;
	int			armor;
	int			money;

	action_t*   menu_src;
	int			menu_id;				// menu
	int			menu_type;
	int			menu_keys;
	int			menu_state;
	float		menu_time;
	player_t*	menu_list[33];			// list of players for stats menu
	int			menu_pplnum;			// number of players in stats menu
	char*		menu_cmds[10];			// custom server commands for custom menu (set by sm_setmenu)

	int			lat_sum;				// latency measure
	int			lat_samples;
	float		lat_time;
	int			lat_spikes;
			
	float		say_flood;				// flood protection
	float		alias_flood;
	float		connect_time;			// internal usage for sm_clexec at client connect
	char		info_off[32];

	player_t*	bleeding;				// for DOD
	int			bleeding_weapon;
	int			bleeding_aiming;

	int			damage_deathmsg;		// for last damage in CS
	int			damage_damage;
	int			damage_aim;
	int			damage_weapon;
	player_t*	damage_attacker;

	//int			sm_mode[10];
	stat_t		aAPpl_stats[33];
	stat_t*		pAPpl_stats;
	int			next_channel;


	player_t() {};
	~player_t() {
		for(int i=0;i<10;++i)
			if (menu_cmds[i])
				delete[] menu_cmds[i];
	};
};

struct grenades_t {
	player_t*	pPlayer;
	edict_t*	pGrenade;
	float		time;
	int			index;
	grenades_t*	next;
	grenades_t*	prev;
};

void DeleteConfiguration(void);
void DeleteStats(stat_t**a, stat_t**b);
void ResetRanking(void);
extern stat_t* sm_rank;
extern stat_t* sm_rank_last;

extern myvar_t	*sm_settings;
extern myvar_t	*sm_logformat;
extern myvar_t	*sm_playerstats;
extern myvar_t	*sm_weaponstats;
extern myvar_t	*sm_latlogformat;
extern myvar_t	*sm_timelogformat;
extern myvar_t	*sm_logformat2;
extern myvar_t	*sm_attackers;
extern myvar_t	*sm_victims;
extern myvar_t	*sm_rankhead;
extern myvar_t	*sm_rankbody;
extern myvar_t	*sm_ranktitle;
extern myvar_t	*sm_rankscore;

class sm_t {
public:

	int				mod_id;
	char			mod_name[32];
	mod_settings_t	mod_set;

#ifdef DEBUG_OPTION
	char			debug_name[128];
#endif

	int				sm_mode_id;
	int				sm_mode_bits;
	int				sm_mode[10];

	float			c4_timing;			// delay between counting down
	int				c4_timer;

	char			teamscore_name[4][32];	// names of teams which are in game
	int				teamscore_id[4];		// keeps id of teams from sm_score for teamscore

	char			team_name[4][32];	// unassigned, spectator, ct (aliases), t (axis)
	int				team_num;
	int				team_players[4];	// keeps number of players in each team

	int				player_count;

	player_t*		killer;
	player_t*		victim;
	player_t*		player;

	player_t*		gm_accurate;
	player_t*		gm_killer;
	player_t*		gm_disruptive;

	player_t*		rnd_accurate;
	player_t*		rnd_killer;
	player_t*		rnd_disruptive;

	stat_t*			rank;
	player_t*		custom;

	stat_t			gamestats[4];		// stats for specified teams
	stat_t			roundstats[4];
	stat_t			all_gamestats;		// for all players
	stat_t			all_roundstats;

	hudtextparms_t	hudset;

	float			game_timeleft;
	float			game_restarting;
	float			endround_time;
	float			endmap_time;
	float			mapstart_time;
	float			newround_time;
	float			freezeend_time;
	float			buyend_time;
	float			task_time;
	float			engine_task;

	time_t			last_reset;			// of top15 rank

	sm_t() { };
	~sm_t() { 	
		DeleteConfiguration(); 
		DeleteStats(&sm_rank, &sm_rank_last); 

		while(sm_settings) {
			myvar_t*b = sm_settings;
			sm_settings = sm_settings->next;
			delete[] b->name;
			delete[] b->string;
			delete b;
		}
	};
};

extern fun_t modMsgs[MAX_REG_MSGS];
extern fun_t modMsgsEnd[MAX_REG_MSGS ];

extern int	gmsgDeathMsg;
extern int	gmsgDamage;
extern int	gmsgCurWeapon;
extern int	gmsgTextMsg;
extern int	gmsgTeamInfo;
extern int	gmsgWeaponList;
extern int	gmsgResetHUD;
//extern int	gmsgInitHUD;
extern int	gmsgMOTD;
extern int	gmsgServerName;
extern int	gmsgintermission;
extern int	gmsgHealth;
extern int	gmsgBattery;
extern int  gmsgShowMenu;
extern int  gmsgSendAudio;
extern int  gmsgTeamScore;
extern int	gmsgMoney;
extern int	gmsgBleeding;
extern int	gmsgBandaging;
extern int  gmsgScreenFade;
extern int	gmsgScoreInfo;

extern char	szBuffor[2048];
extern char	parseMsg[768];
extern int parsePos;

extern void (*endfunction)(void*);
extern fun_call_t* modMsgsFunCall[ MAX_SM_REG_MSGS ];
extern msg_vault_t parseVault[MAX_PARSE_VALUES];
extern player_t* mPlayer;
extern int mPlayerIndex;
extern int mState;


extern player_t		players[33];
extern wpn_sel_t	weapon_select[MAX_WEAPONS];
extern wpn_sel_t	weapon_select_cs[MAX_WEAPONS];
extern wpn_sel_t	weapon_select_dod[MAX_WEAPONS];
extern myvar_t*		sm_var;
extern task_t*		sm_task;
extern grenades_t*	sm_grenades;
extern action_t*	sm_alias;
extern action_t*	sm_menu;
extern action_t*	sm_pmenu;
extern motd_t*		sm_motd;
extern sm_t			sm;
extern engtask_t*	sm_engtask;

extern int			player_bits;

extern cvar_t	*statsme_version;
extern cvar_t	*sm_refresh;
extern cvar_t	*sm_monsternum;
extern cvar_t	*sm_menupassword;
extern cvar_t	*sm_monsterfreq;
extern cvar_t	*sm_rankcmd;
extern cvar_t	*sm_statsmecmd;
extern cvar_t	*sm_statscmd;
extern cvar_t	*sm_killsforrank;
extern cvar_t	*sm_resetrank;
extern cvar_t	*sm_latlogfreq;
extern cvar_t	*sm_ranklogfile;
extern cvar_t	*sm_resetonrestart;
extern cvar_t	*mp_timelimit;
extern cvar_t	*sm_logmenuaction;
extern cvar_t	*sm_switchinfo;
extern cvar_t	*sm_flood;
extern cvar_t	*sm_debug;
extern cvar_t	*sm_rankupdate;
extern cvar_t	*sm_rankbots;
extern cvar_t	*sm_addonlogformat;
extern cvar_t	*sm_storebyauth;
extern cvar_t	*sm_punishnocd;
extern cvar_t	*sm_enabled;
extern cvar_t	*sm_pingspike;
extern cvar_t	*sm_smarthud;
extern cvar_t	*sm_htmlbgcolor;
extern cvar_t	*sm_htmlfgcolor;
extern cvar_t	*sm_htmlfont;
extern cvar_t	*sm_htmlvgui2;


char* smv_pre_proc(const char* src);
char* smv_putvars(register const char* src);

myvar_t* findVar(myvar_t** b, const char* name);

char* UTIL_RemoveQuotes(char* arg);
char* UTIL_Itoa(int i);
bool UTIL_IsDigit(const char* value);
const char* GetPlayerValue(player_t *pPlayer, const char* src);
//void UTIL_GetModName(char* name, int* id);
const char* UTIL_Pathname( char *fmt, ... );
char* UTIL_SplitHudMessage(register const char *pMessage);
char* UTIL_PutSpecChars(register const char* b);
char* MakeStats(player_t *pPlayer, char* pList);
char* GetAttackersList(player_t *pPlayer);
char* GetVictimsList(player_t *pPlayer);
stat_t* FindThePositionInRank(const char* name, const char* authid);
void ScorePlayerInRank(const char* name, stat_t* p, stat_t* a);
void ShowTopScore(player_t* pPlayer);
void UTIL_ShowMOTD( edict_t *client , char *motd, const char *name);
void UTIL_HudMessage(edict_t *pEntity, const hudtextparms_t &textparms, char *pMessage);
void UTIL_HudMessage2(edict_t *pEntity, const hudtextparms_t &textparms, char *pMessage, int channel);
int UTIL_NextChannel(player_t *pPlayer);
void UTIL_ClientPrint( edict_t *pEntity, int msg_dest, char *pMessage);
void UTIL_IntToString(int iValue, char *szOutput);
void UTIL_ShowMenu(  edict_t* pEdict, int slots, int time,  char *menu );
void UTIL_GetSystemTime(char* dest, unsigned int size, const char* format);
void SettingsMenu(player_t *pPlayer, int state, action_t* a);
void StatsMenu(player_t *pPlayer, int state);
void LoadRank(void);
void LoadPStatsInfo(void);
void SaveRank(void);
void statsme_init(void);
void PlayerConnect(edict_t *pEntity, const char *pszName, const char *pszAddress);
//void HandleConnect(int id);
void PlayerPutInServer( player_t* pPlayer );
void PlayerDisconnect( player_t *pPlayer);
void ResetStats( player_t* pPlayer );
void CmdTell(void);
void CmdAlias(void);
void CmdClExec(void);
void CmdMotd(void);
void CmdShowMenu(void);
void CmdMenuCmds(void);
void ResetStats( player_t* pPlayer );
bool FloodProtection( float* time );
bool UTIL_ValidPlayer(player_t* pPlayer, const char* arg);
int UTIL_ReadFlags(const char* c);
player_t* UTIL_GetPlayerByName(const char* name);
int UTIL_GetPlayersNumber();

// global Mod Support
void Client_SM_DeathMsg(void*);
void Client_SM_Damage(void*);

void Client_Battery(void*);
void Client_ShowMenu(void*);
void Client_intermission_End(void*);
void Client_TeamInfo(void*);
void Client_Health(void*);
void Client_TeamScore(void*);
void Client_ResetHUD_End(void* mValue);
void Client_WeaponList(void*);
void Client_CurWeapon(void*);
void Client_DeathMsg(void*);

// CS support
void Client_DeathMsg_CS(void*);
void Client_Damage_CS(void*);
void Client_TextMsg_CS(void*);
void Client_ResetHUD_End_CS(void*);
void Client_SendAudio_CS(void*);
void Client_Money_CS(void*);
void EmitSound_CS(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int fFlags, int pitch);
void SetModel_CS(edict_t *e, const char *m);
void StartFrame_CS( void );  
void Client_CurWeapon_CS(void*);

// DOD support
void Client_Health_DOD(void*);
void Client_Bleeding_DOD(void*);
void Client_Bandaging_DOD(void*);
void Client_DeathMsg_DOD(void*);
// void Client_TextMsg_DOD(void*);
void SetModel_DOD(edict_t *e, const char *m);
void EmitSound_DOD(edict_t *entity, int channel, const char *sample, /*int*/float volume, float attenuation, int fFlags, int pitch);
void Client_ScreenFade_DOD (void*);  // FIX for SturmBot
void Client_ResetHUD_End_DOD(void* mValue);
void Client_CurWeapon_DOD(void*);

// TFC support
//void Client_CurWeapon_TFC(void*);
//void Client_InitHUD_TFC(void*);
//void SetModel_TFC(edict_t *e, const char *m);
void Client_DeathMsg_TFC(void* mValue);
void Client_WeaponList_TFC(void* mValue);
//void Client_Damage_TFC(void* mValue);
void Client_ScoreInfo_TFC(void*);
void Client_AmmoX_TFC(void*);


void StartFrame( void );
void FireShot(player_t* pPlayer, int weapon);
void FireHit(player_t* pVictim,player_t* pAttacker ,int weapon, int damage, int aimed_at);
void FireKill(player_t* pVictim, player_t* pKiller, int weapon, int hs, bool tk);

void PutGrenade(edict_t* pGre, float time,int type, player_t* pPlayer);
grenades_t* FindGrenade(edict_t* enemy);

void PARSE_MESSAGE_BEGIN(int msg_type, player_t* target = NULL, int index = 0);
void PARSE_MESSAGE_END(void);
void PARSE_INTEGER(int iValue);
void PARSE_FLOAT(float fValue);
void PARSE_STRING(const char *sz);

//void SET_CLIENT_TASK(int id, const char* cmd );

#endif // STATSME_H
