/*
Copyright 2002 - 2004 UnitedAdmins
Project originally created by OLO (http://olo.counter-strike.pl)

This file is part of StatsMe.

   StatsMe is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   StatsMe is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with StatsMe; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   A copy of the GNU General Public License is available in a file called COPYING.
   See README for more information.

*/

/* $Id: statsme_cmd.cpp,v 1.39 2004/06/16 14:31:41 punisher Exp $ */

#include <extdll.h>			// always

#include <api_info.h>		// api_info_t, etc
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include "statsme.h"	// me
#include <ctype.h>

myvar_t *sm_settings;
myvar_t	*sm_logformat;
myvar_t	*sm_playerstats;
myvar_t	*sm_weaponstats;
myvar_t *sm_latlogformat;
myvar_t *sm_timelogformat;
myvar_t *sm_logformat2;
myvar_t	*sm_attackers;
myvar_t	*sm_victims;
myvar_t	*sm_rankhead;
myvar_t	*sm_rankbody;
myvar_t	*sm_ranktitle;
myvar_t	*sm_rankscore;

cvar_t	*sm_ranklogfile;
cvar_t	*statsme_version;
cvar_t	*sm_monsternum;
cvar_t	*sm_monsterfreq;
cvar_t	*sm_logmenuaction;
cvar_t	*sm_switchinfo;
cvar_t	*sm_menupassword;
cvar_t	*sm_killsforrank;
cvar_t	*sm_rankcmd;
cvar_t	*sm_statsmecmd;
cvar_t	*sm_statscmd;
cvar_t	*sm_resetrank;
cvar_t  *sm_latlogfreq;
cvar_t	*sm_resetonrestart;
cvar_t	*mp_timelimit;
cvar_t	*sm_refresh;
cvar_t	*sm_flood;
cvar_t	*sm_rankupdate;
cvar_t	*sm_rankbots;
cvar_t  *sm_addonlogformat;
cvar_t  *sm_storebyauth;
cvar_t	*sm_punishnocd;
cvar_t	*sm_enabled;
cvar_t	*sm_pingspike;
cvar_t	*sm_smarthud;
bool is_message_set;

// CVars for HTML output
cvar_t *sm_htmlbgcolor;
cvar_t *sm_htmlfgcolor;
cvar_t *sm_htmlfont;
cvar_t *sm_htmlvgui2;

#ifdef DEBUG_OPTION
	cvar_t	*sm_debug;
	cvar_t	init_sm_debug				=	{"sm_debug","0",0,0};
#endif

cvar_t	init_statsme_version		=	{"statsme_version",VVERSION, FCVAR_EXTDLL | FCVAR_SPONLY};
cvar_t	init_sm_menupassword		=	{"sm_menupassword","",FCVAR_EXTDLL | FCVAR_PROTECTED};
cvar_t	init_sm_monsternum			=	{"sm_monsternum","3",FCVAR_EXTDLL,3};
cvar_t	init_sm_monsterfreq			=   {"sm_monsterfreq","4",FCVAR_EXTDLL,4};
cvar_t	init_sm_killsforrank		=	{"sm_killsforrank","30",FCVAR_EXTDLL,30};
cvar_t	init_sm_statsmecmd			=	{"sm_statsmecmd","statsme",FCVAR_EXTDLL};
cvar_t	init_sm_statscmd			=	{"sm_statscmd","smstats",FCVAR_EXTDLL};
cvar_t	init_sm_rankcmd				=	{"sm_rankcmd","top10",FCVAR_EXTDLL};
cvar_t	init_sm_ranklogfile			=	{"sm_ranklogfile","statsme.log",FCVAR_EXTDLL};
cvar_t	init_sm_switchinfo			=	{"sm_switchinfo","statsme", FCVAR_EXTDLL};
cvar_t	init_sm_resetrank			=	{"sm_resetrank","144",FCVAR_EXTDLL,144};
cvar_t  init_sm_latlogfreq			=	{"sm_latlogfreq","20",FCVAR_EXTDLL,20};
cvar_t	init_sm_resetonrestart		=	{"sm_resetonrestart","1",FCVAR_EXTDLL,1};
cvar_t	init_sm_logmenuaction		=	{"sm_logmenuaction","0",FCVAR_EXTDLL,0};
cvar_t	init_sm_refresh				=	{"sm_refresh","1",FCVAR_EXTDLL,1};
cvar_t	init_sm_flood				=	{"sm_flood","0.015",FCVAR_EXTDLL,0.015};
cvar_t	init_sm_rankupdate			=	{"sm_rankupdate","2",FCVAR_EXTDLL,2};
cvar_t	init_sm_rankbots			=	{"sm_rankbots","0",FCVAR_EXTDLL,0};
cvar_t	init_sm_addonlogformat		=	{"sm_addonlogformat","2",FCVAR_EXTDLL,2};
cvar_t	init_sm_storebyauth			=	{"sm_storebyauth", "0",FCVAR_EXTDLL,0};
cvar_t	init_sm_punishnocd			=	{"sm_punishnocd", "1",FCVAR_EXTDLL,1};
cvar_t	init_sm_enabled				=	{"sm_enabled", "1",FCVAR_EXTDLL,1};
cvar_t	init_sm_pingspike			=	{"sm_pingspike", "0",FCVAR_EXTDLL,0};
cvar_t	init_sm_smarthud			=	{"sm_smarthud", "0",FCVAR_EXTDLL,0};

cvar_t init_sm_htmlbgcolor			=	{"sm_htmlbgcolor","#000000",FCVAR_EXTDLL};
cvar_t init_sm_htmlfgcolor			=	{"sm_htmlfgcolor","#FFB000",FCVAR_EXTDLL};
cvar_t init_sm_htmlfont				=	{"sm_htmlfont","Verdana,Tahoma",FCVAR_EXTDLL};
cvar_t init_sm_htmlvgui2			=	{"sm_htmlvgui2","1",FCVAR_EXTDLL,1};


void CmdSomeSets(void) {
	myvar_t* a = findVar(&sm_settings, CMD_ARGV(0));
	delete[] a->string;
	const char* code = smv_pre_proc(CMD_ARGV(1));
	int len = strlen(code);
	a->string = new char [len + 1];
	strcpy(a->string, code);
}

void CmdReg(void) {

	static struct sm_events_t {	
		const char* name;
		int	value;
	} sm_events[] = { 
		{"SM_DeathMsg",SM_DEATHMSG},
		{"SM_RoundEnd",SM_ROUNDEND},
		{"SM_RoundStart",SM_ROUNDSTART},
		{"SM_MonsterKill",SM_MONSTERKILL},
		{"SM_C4Timer",SM_C4TIMER},
		{"SM_Damage",SM_DAMAGE},
		{"SM_InfoChanged",SM_INFOCHANGED},
		{"SM_Connect",SM_CONNECT},
		{"SM_Disconnect",SM_DISCONNECT},
		{"SM_PutInServer",SM_PUTINSERVER},
		{"SM_MapStart",SM_MAPSTART},
		{"SM_Lastman",SM_LASTMAN},
		{"SM_FreezetimeStart",SM_FREEZETIMESTART},
		{"SM_FreezetimeEnd",SM_FREEZETIMEEND},
		{"SM_BuytimeStart",SM_BUYTIMESTART},
		{"SM_BuytimeEnd",SM_BUYTIMEEND},
		{"",0}
	};

	if (CMD_ARGC() < 4)	{
		SERVER_PRINT("Usage:  sm_register < event [ flag for sm_mode ] [ sm_mode id ] > < command > < flags > [ conditions ] ...\n");
		return;
	}
	char event_name[32]; 
	char event_regid[32]; event_regid[0]=0;
	char event_mode = '0';
	sscanf(CMD_ARGV(1),"%32s %32s %c",event_name,event_regid,&event_mode);
	event_mode = event_mode - '0';
	int regid = *event_regid ? UTIL_ReadFlags(event_regid) : 0;
	int pos = atoi( event_name );
	if (!pos) {
		for(int j = 0; sm_events[j].value ; ++j){
			if ( !strcmp( sm_events[j].name , event_name ) ){
				pos = sm_events[j].value;
				break;
			}
		}
	}
	if (!pos)	{
		pos = GET_USER_MSG_ID(PLID, event_name , NULL );
	}

	char* command = smv_pre_proc(CMD_ARGV(2));
	int len = strlen( command );
	if (!pos || !len)  return;
/*	fun_call_t* events = modMsgsFunCall[pos];
	while ( events ) {
		if ( !strcmp( events->cmd, command ) )	{
//			LOG_MESSAGE(PLID,  "WARNING: (sm_register) duplicate entry.");
			return;
		}
		events = events->next;
	} */
	int arg_num = CMD_ARGC();			
	int parm = UTIL_ReadFlags(CMD_ARGV(3));
	fun_call_t* new_object = new fun_call_t;
	new_object->cmd = new char[len+1];
	strcpy(new_object->cmd, command );
	new_object->len = len;
	new_object->where = 64 - len;
	new_object->flag = regid;
	new_object->mode = event_mode;
	memset(new_object->cond,0,sizeof(new_object->cond));
	new_object->stamp = 0.0;
	new_object->done = false;
	new_object->alive=true;
	new_object->dead=true;
	new_object->world=(parm&1)?true:false;
	new_object->player=(parm&2)?true:false;
	new_object->once=(parm&4)?true:false;
	new_object->quotes=(parm&8)?0:1;
	new_object->fillme=(parm&16)?true:false;
	new_object->whole=(parm&32)?true:false;
	if ( parm & 192 ){ // rules about live status specified!
		new_object->alive=(parm&64)?true:false;
		new_object->dead=(parm&128)?true:false;
	}
	if (arg_num > 4){
		for(int i = 4; i < arg_num; ++i){	//add conditions (i.e. "2=#Terrorist_Wins")	
			char* cond = (char*)CMD_ARGV(i);
			char* cond_txt = cond;
			cond_t* new_one = new cond_t;
			while ( isdigit(*cond_txt) )
				++cond_txt;
			new_one->type = *cond_txt;
			*cond_txt = '\0';
			cond_txt++;
			int cp = atoi(cond);
			if (cp < 0 || cp > 19) cp = 0;
			new_one->len = strlen(cond_txt);
			new_one->sValue = new char[ new_one->len + 1 ];
			strcpy( new_one->sValue, cond_txt);
			new_one->fValue = atof(cond_txt);
			new_one->iValue = atoi(cond_txt);
			new_one->next = new_object->cond[cp];
			new_object->cond[cp] = new_one;
		}
	}
	new_object->next = NULL; //at at the end of list
	if (modMsgsFunCall[pos]){
		fun_call_t*start = modMsgsFunCall[pos];
		while (start->next)
			start = start->next;
		start->next = new_object;
	}
	else {
		modMsgsFunCall[pos] = new_object;
	}
}

void CmdScoreTeams()
{
	if (CMD_ARGC() < 2)	{
		SERVER_PRINT("Usage:  sm_score < team name > < team name >\n");
		return;
	}

	for (int i = 0; i < 4 && i < CMD_ARGC() ; ++i)
		strcpy(sm.teamscore_name[i],CMD_ARGV(i + 1));
}

void CmdSetMode(void){

	if (CMD_ARGC() < 3)	{
		SERVER_PRINT("Usage:  sm_mode[ id ] < set | remove > < bits > \n");
		return;
	}

	int value = UTIL_ReadFlags(CMD_ARGV(2));
	int c = CMD_ARGV(0)[7];
	int mode = c ? c - '0' : 0;
	if (!strcmpi(CMD_ARGV(1),"set"))
		sm.sm_mode[mode] |= value;
	else if (!strcmpi(CMD_ARGV(1),"remove"))
		sm.sm_mode[mode] &= ~value;
}

void CmdTask(void) 
{
	if (CMD_ARGC() < 3) {
		SERVER_PRINT("Usage:  sm_task < time in sec. > < command > [ flags ]\n");
		return;
	}
	task_t*a = new task_t;
	const char* me = smv_pre_proc(CMD_ARGV(2));
	a->cmd = new char[strlen(me)+1];
	strcpy(a->cmd,me);
	float time = atof( CMD_ARGV(1) );
	int flags = UTIL_ReadFlags( CMD_ARGV(3) );
	a->flags = flags;
	a->time = gpGlobals->time + time;
	a->root_time = time;
	a->prev = NULL;
	a->next = sm_task;
	if (sm_task) sm_task->prev = a;
	sm_task = a;
}

void CmdDo(void) 
{
	
	if (CMD_ARGC() < 2) {
		SERVER_PRINT("Usage:  sm_do < command >\n");
		return;
	}

	char* arg = UTIL_RemoveQuotes((char*)CMD_ARGS());

	arg = smv_putvars( smv_pre_proc(arg) );

	if (arg && *arg) SERVER_COMMAND(arg);
}

void CmdAlias(void) 
{
	if (CMD_ARGC() < 4) {
		SERVER_PRINT("Usage:  sm_alias < alias > < command > < flags >\n");
		return;
	}

	const char* name = CMD_ARGV(1);
	const char* cmd = smv_pre_proc(CMD_ARGV(2));
	action_t* start = sm_alias;
	while (start)	{
		if ( !strcmp(start->name,name) && !strcmp(start->cmd,cmd) )	{
//			LOG_MESSAGE(PLID,  "WARNING: (sm_alias) duplicate entry.");
			return;
		}
		start = start->next;
	} 
	
	action_t* new_one = new action_t;
	new_one->name = new char[strlen(name)+1];
	new_one->cmd = new char[strlen(cmd)+1];
	strcpy(new_one->name,name);
	strcpy(new_one->cmd,cmd);
	new_one->flags = UTIL_ReadFlags(CMD_ARGV(3));
	new_one->next = sm_alias;
	sm_alias = new_one;
}

void CmdMenu(void) 
{

	if (CMD_ARGC() < 3) {
		SERVER_PRINT("Usage:  sm_menu < description > < command >\n");		
		return;
	}
	
	const char* name = smv_pre_proc(CMD_ARGV(1));
	const char* cmd = smv_pre_proc(CMD_ARGV(2));
	action_t** a = &sm_menu;
/*	action_t* start = *a;
	while (start){
		if ( !strcmp(start->name,name) && !strcmp(start->cmd,cmd) )	{
			LOG_MESSAGE(PLID,  "WARNING: (sm_menu) duplicate entry.");
			return;
		}
		start = start->next;
	} */
	action_t* new_one=new action_t;
	new_one->name = new char[strlen(name)+1];
	new_one->cmd = new char[strlen(cmd)+1];
	strcpy(new_one->name,name);
	strcpy(new_one->cmd,cmd);
	new_one->next = NULL;
	if ( *a ){  //at at the end of list
		action_t* start = *a;
		while (start->next)
			start = start->next;
		start->next = new_one;
	}
	else {
		*a = new_one;
	}
}

void CmdLog(void) 
{
	if (CMD_ARGC() < 2) {
		SERVER_PRINT("Usage:  sm_log < event >\n");
		return;
	}

#ifdef ADDON_LAYOUT
	ALERT( at_logged,"[%s] %s",Plugin_info.logtag, UTIL_PutSpecChars( CMD_ARGS() ) );
#else
	ALERT( at_logged, UTIL_PutSpecChars( CMD_ARGS() ) );
#endif
}

void CmdSayFrmt(void)
{
	if (CMD_ARGC() < 2){
		SERVER_PRINT("Usage:  sm_sayformat < settings >\n");
		return;
	}
	sm.hudset.a1 = 0;sm.hudset.a2 = 0;
	sm.hudset.r2 = 255;sm.hudset.g2 = 255;sm.hudset.b2 = 250;
	sm.hudset.r1 = atoi(CMD_ARGV(1));	
	sm.hudset.g1 = atoi(CMD_ARGV(2));		
	sm.hudset.b1 = atoi(CMD_ARGV(3));	
	sm.hudset.x = atof(CMD_ARGV(4));	  
	sm.hudset.y = atof(CMD_ARGV(5));		
	sm.hudset.effect = atoi(CMD_ARGV(6));	
	sm.hudset.fxTime = atof(CMD_ARGV(7));		
	sm.hudset.holdTime = atof(CMD_ARGV(8));	
	sm.hudset.fadeinTime = atof(CMD_ARGV(9));		
	sm.hudset.fadeoutTime = atof(CMD_ARGV(10));	
	sm.hudset.channel = atoi(CMD_ARGV(11));
}



void CmdTell(void)
{
	if (sm_enabled->value == 0) {
		return;
	}
	if (CMD_ARGC() < 3){
		SERVER_PRINT("Usage:  sm_tell < * | #userid | team > < message > [ 1 | 2 | 3 | 4 ]\n");
		return;
	}
	int dest = atoi(CMD_ARGV(3));
	char* todo = UTIL_PutSpecChars( CMD_ARGV(2) );
	char* msg = dest ? todo : UTIL_SplitHudMessage( todo );		
	for (int i = 1; i <= gpGlobals->maxClients;++i)	{
		player_t *pPlayer = GET_PLAYER_POINTER_I(i);
		if( !strcmp(pPlayer->info_off,"0") ) continue;
		if ( UTIL_ValidPlayer(pPlayer,CMD_ARGV(1)) )
			if ( dest )	
				UTIL_ClientPrint(pPlayer->pEdict, dest , msg );
			else {

				if (!sm.hudset.channel || sm_smarthud->value) {   // 0 channel, use dynamic channels and position

					int nc = UTIL_NextChannel(pPlayer);
					sm.hudset.x = 0.025;
					sm.hudset.y = 0.35 + ( 0.075 * (nc-1) );

					UTIL_HudMessage2(pPlayer->pEdict, sm.hudset, msg, nc + 1 );  // 2,3,4 -- save 1 for AM csay
				} else {
					UTIL_HudMessage(pPlayer->pEdict, sm.hudset, msg);
				}
			}
	}
}

void CmdTell2(void)
{
	if (sm_enabled->value == 0) {
		return;
	}
	if (CMD_ARGC() < 3){
		SERVER_PRINT("Usage:  sm_tell2 < * | #userid | team > < message > [ 1 | 2 | 3 | 4 ]\n");
		return;
	}
	int dest = atoi(CMD_ARGV(3));
	char* todo = UTIL_PutSpecChars( CMD_ARGV(2) );
	char* msg = dest ? todo : UTIL_SplitHudMessage( todo );		
	for (int i = 1; i <= gpGlobals->maxClients;++i)	{
		player_t *pPlayer = GET_PLAYER_POINTER_I(i);
		if ( UTIL_ValidPlayer(pPlayer,CMD_ARGV(1)) )
			if ( dest )	
				UTIL_ClientPrint(pPlayer->pEdict, dest , msg );
			else {
				if (!sm.hudset.channel || sm_smarthud->value) {   // 0 channel, use dynamic channels and position

					int nc = UTIL_NextChannel(pPlayer);
					sm.hudset.x = 0.025;
					sm.hudset.y = 0.35 + ( 0.075 * (nc-1) );

					UTIL_HudMessage2(pPlayer->pEdict, sm.hudset, msg, nc + 1 );  // 2,3,4 -- save 1 for AM csay
				} else {
					UTIL_HudMessage(pPlayer->pEdict, sm.hudset, msg);
				}
			}
	}
}


void CmdWin(void)
{
	if (sm_enabled->value == 0) {
		return;
	}
	if (CMD_ARGC() < 3){
		SERVER_PRINT("Usage:  sm_win < * | #userid | team > < message > [ header ]\n");
		return;
	}
	char* toshow = UTIL_PutSpecChars( CMD_ARGV(2) );
	const char* forhead = CMD_ARGV(3);
	if (!*forhead) forhead = CVAR_GET_STRING("hostname");
	for (int i = 1; i <= gpGlobals->maxClients;++i)	{
		player_t *pPlayer = GET_PLAYER_POINTER_I(i);
		if( !strcmp(pPlayer->info_off,"0") ) continue;
		if ( UTIL_ValidPlayer(pPlayer,CMD_ARGV(1) ) ) {
			UTIL_ShowMOTD(pPlayer->pEdict, toshow , forhead);
		}
	}
}

void CmdWin2(void)
{
	if (sm_enabled->value == 0) {
		return;
	}
	if (CMD_ARGC() < 3){
		SERVER_PRINT("Usage:  sm_win2 < * | #userid | team > < message > [ header ]\n");
		return;
	}
	char* toshow = UTIL_PutSpecChars( CMD_ARGV(2) );
	const char* forhead = CMD_ARGV(3);
	if (!*forhead) forhead = CVAR_GET_STRING("hostname");
	for (int i = 1; i <= gpGlobals->maxClients;++i)	{
		player_t *pPlayer = GET_PLAYER_POINTER_I(i);
		if ( UTIL_ValidPlayer(pPlayer,CMD_ARGV(1) ) ) {
			UTIL_ShowMOTD(pPlayer->pEdict, toshow , forhead);
		}
	}
}


void CmdClExec(void)
{
	if (sm_enabled->value == 0) {
		return;
	}
	if (CMD_ARGC() < 3) {
		SERVER_PRINT("Usage:  sm_clexec < * | #userid | team > < command >\n");
		return;
	}
	char* todo = UTIL_PutSpecChars( CMD_ARGV(2) );
	for (int i = 1; i <= gpGlobals->maxClients;++i)	{
		player_t *pPlayer = GET_PLAYER_POINTER_I(i);	
		if( !strcmp(pPlayer->info_off,"0") ) continue;
		if (UTIL_ValidPlayer(pPlayer,CMD_ARGV(1))) { // || pPlayer->connect_time > gpGlobals->time){
			CLIENT_COMMAND(pPlayer->pEdict, todo );
		}
	}
}

void CmdClExec2(void)
{
	if (sm_enabled->value == 0) {
		return;
	}
	if (CMD_ARGC() < 3) {
		SERVER_PRINT("Usage:  sm_clexec2 < * | #userid | team > < command >\n");
		return;
	}
	char* todo = UTIL_PutSpecChars( CMD_ARGV(2) );
	for (int i = 1; i <= gpGlobals->maxClients;++i)	{
		player_t *pPlayer = GET_PLAYER_POINTER_I(i);	
		if (UTIL_ValidPlayer(pPlayer,CMD_ARGV(1))) { // || pPlayer->connect_time > gpGlobals->time){
			CLIENT_COMMAND(pPlayer->pEdict, todo );
		}
	}
}

void CmdShowMenu(void)
{
	if (sm_enabled->value == 0) {
		return;
	}
	if (CMD_ARGC() < 3) {
		SERVER_PRINT("Usage:  sm_showmenu < * | #userid | team > < menu > < keys > < menuid > [ time in sec. ]\n");
		return;
	}
	static int char_keys[10] = {512,1,2,4,8,16,32,64,128,256};
	const char *slots = CMD_ARGV(3);
	int menuid = atoi(CMD_ARGV(4)), keys = 0;
	int displaytime = (CMD_ARGC()>5)?atoi(CMD_ARGV(5)):-1;
	char* sMenu = UTIL_PutSpecChars( CMD_ARGV(2) );
	if (*slots == 'b') //when slots begings with 'b' then value is already generated (f.e. "b519")
		keys = atoi(++slots);
	else //without - we must convert 1, 2, 3, 0 to 1, 2, 4, 512
		while (*slots)	keys |= char_keys[ ( *slots++ - '0' ) ];
	for (int i = 1; i <= gpGlobals->maxClients;++i)	{
		player_t *pPlayer = GET_PLAYER_POINTER_I(i);
		if( UTIL_ValidPlayer(pPlayer,CMD_ARGV(1)) ){
			UTIL_ShowMenu( pPlayer->pEdict, keys, displaytime, sMenu );
			pPlayer->menu_keys  = keys;
			pPlayer->menu_id	= menuid;
			pPlayer->menu_type	= CUSTOM_MENU;
			if (sm_logmenuaction->value)
#ifdef ADDON_LAYOUT
				ALERT( at_logged,"[%s] \"%s<%i><%s><%s>\" triggered \"show_menu\" (menu \"%d\")\n",Plugin_info.logtag,
#else
				ALERT( at_logged,"\"%s<%i><%s><%s>\" triggered \"show_menu\" (menu \"%d\")\n",
#endif
				STRING( pPlayer->pEdict->v.netname ), 	
				GETPLAYERUSERID( pPlayer->pEdict ),
				GETPLAYERAUTHID( pPlayer->pEdict ),	
				pPlayer->team_name,pPlayer->menu_id);
		}
	}
}

void CmdSetMenu()
{
	if (CMD_ARGC() < 2) {
		SERVER_PRINT("Usage:  sm_setmenu < * | #userid | team > [ menu cmd. ] ...\n");
		return;
	}
	for (int i = 1; i <= gpGlobals->maxClients;++i)	{
		player_t *pPlayer = GET_PLAYER_POINTER_I(i);
		if( UTIL_ValidPlayer(pPlayer,CMD_ARGV(1)) ){
			for (int a = 2; a <= CMD_ARGC(); a++)	{
				char* todo = UTIL_PutSpecChars( CMD_ARGV(a) );
				int b = a-2;
				if (pPlayer->menu_cmds[b])
					delete[] pPlayer->menu_cmds[b];
				pPlayer->menu_cmds[b] = new char[ strlen( todo ) + 1];
				strcpy( pPlayer->menu_cmds[b] , todo );
			}
		}
	}
}

void CmdMotd(void) 
{
	if (CMD_ARGC() < 2) {
		SERVER_PRINT("Usage:  sm_motd < string >\n");
		return;
	}
	const char* motd = 	smv_pre_proc(CMD_ARGS());

/*	motd_t*motds = sm_motd;
	while ( motds ) {
		if ( !strcmp( motds->msg, motd ) )	{
//			LOG_MESSAGE(PLID, "WARNING: (sm_motd) duplicate entry.");
			return;
		}
		motds = motds->next;
	} */
	motd_t*new_one=new motd_t;
	new_one->msg = new char[strlen(motd)+1];
	strcpy(new_one->msg ,motd);
	new_one->next = NULL;
	if (sm_motd){
		motd_t*start = sm_motd;
		while (start->next)
			start = start->next;
		start->next = new_one;
	}
	else {
		sm_motd = new_one;
	}
}

void CmdUserVal(void)
{
	if (CMD_ARGC() < 2){
		SERVER_PRINT("Usage:  sm_userval < * | #userid | team > < index > < modifier >\n");
		return;
	}

	int dex = 0;

	for (int i = 1; i <= gpGlobals->maxClients;++i)	{
		player_t *pPlayer = GET_PLAYER_POINTER_I(i);
		if ( UTIL_ValidPlayer(pPlayer,CMD_ARGV(1)) ) {

			dex = atoi(CMD_ARGV(2));
			if (dex) {
				int modifier = atoi(CMD_ARGV(3));
				pPlayer->aRnd_stats.userdefined[dex - 1] = pPlayer->aRnd_stats.userdefined[dex - 1] + modifier;
				pPlayer->aGm_stats.userdefined[dex - 1] = pPlayer->aGm_stats.userdefined[dex - 1] + modifier;
			}

		}

	}

}

// Plugin startup.  Register commands and cvars.
void statsme_init(void) {
	
	LOG_MESSAGE(PLID, "%s %s, %s", Plugin_info.name, Plugin_info.version, Plugin_info.date);
	LOG_MESSAGE(PLID, "by %s", Plugin_info.author);
	LOG_MESSAGE(PLID, "   http://%s/", Plugin_info.url);
	LOG_MESSAGE(PLID, "compiled: %s", __DATE__ ", " __TIME__);

	REG_SVR_COMMAND ("sm_clexec", CmdClExec);
	REG_SVR_COMMAND ("sm_clexec2", CmdClExec2);
	REG_SVR_COMMAND ("sm_tell", CmdTell);
	REG_SVR_COMMAND ("sm_tell2", CmdTell2);
	REG_SVR_COMMAND ("sm_win", CmdWin);
	REG_SVR_COMMAND ("sm_win2", CmdWin2);
	REG_SVR_COMMAND ("sm_motd", CmdMotd);
	REG_SVR_COMMAND ("sm_register", CmdReg);
	REG_SVR_COMMAND ("sm_reg", CmdReg);
	REG_SVR_COMMAND ("sm_mode", CmdSetMode);
	REG_SVR_COMMAND ("sm_mode1", CmdSetMode);
	REG_SVR_COMMAND ("sm_mode2", CmdSetMode);
	REG_SVR_COMMAND ("sm_mode3", CmdSetMode);
	REG_SVR_COMMAND ("sm_mode4", CmdSetMode);
	REG_SVR_COMMAND ("sm_mode5", CmdSetMode);
	REG_SVR_COMMAND ("sm_mode6", CmdSetMode);
	REG_SVR_COMMAND ("sm_mode7", CmdSetMode);
	REG_SVR_COMMAND ("sm_mode8", CmdSetMode);
	REG_SVR_COMMAND ("sm_mode9", CmdSetMode);
	REG_SVR_COMMAND ("sm_menu", CmdMenu);
	REG_SVR_COMMAND ("sm_log", CmdLog);
	REG_SVR_COMMAND ("sm_alias", CmdAlias);
	REG_SVR_COMMAND ("sm_task", CmdTask);
	REG_SVR_COMMAND ("sm_showmenu", CmdShowMenu);
	REG_SVR_COMMAND ("sm_do", CmdDo);	
	REG_SVR_COMMAND ("sm_setmenu", CmdSetMenu);
	REG_SVR_COMMAND ("sm_score", CmdScoreTeams);
	REG_SVR_COMMAND ("sm_sayformat", CmdSayFrmt);
	REG_SVR_COMMAND ("sm_clearrank", ResetRanking);
	REG_SVR_COMMAND ("sm_userval", CmdUserVal);

	// some log formats under commands
	REG_SVR_COMMAND ("sm_rankhead", CmdSomeSets);
	REG_SVR_COMMAND ("sm_rankbody", CmdSomeSets);
	REG_SVR_COMMAND ("sm_ranktitle", CmdSomeSets);
	REG_SVR_COMMAND ("sm_rankscore", CmdSomeSets);
	REG_SVR_COMMAND ("sm_timelogformat", CmdSomeSets);
	REG_SVR_COMMAND ("sm_playerstats", CmdSomeSets);
	REG_SVR_COMMAND ("sm_weaponstats", CmdSomeSets);
	REG_SVR_COMMAND ("sm_latlogformat", CmdSomeSets);
	REG_SVR_COMMAND ("sm_logformat2", CmdSomeSets);
	REG_SVR_COMMAND ("sm_attackers", CmdSomeSets);
	REG_SVR_COMMAND ("sm_victims", CmdSomeSets);
	REG_SVR_COMMAND ("sm_logformat", CmdSomeSets);
	
	sm_rankhead = findVar(&sm_settings,"sm_rankhead");
	sm_rankbody = findVar(&sm_settings,"sm_rankbody");
	sm_ranktitle = findVar(&sm_settings,"sm_ranktitle");
	sm_rankscore = findVar(&sm_settings,"sm_rankscore");
	sm_timelogformat = findVar(&sm_settings,"sm_timelogformat");
	sm_playerstats = findVar(&sm_settings,"sm_playerstats");
	sm_weaponstats = findVar(&sm_settings,"sm_weaponstats");
	sm_latlogformat = findVar(&sm_settings,"sm_latlogformat");
	sm_logformat2 = findVar(&sm_settings,"sm_logformat2");
	sm_attackers = findVar(&sm_settings,"sm_attackers");
	sm_victims = findVar(&sm_settings,"sm_victims");
	sm_logformat = findVar(&sm_settings,"sm_logformat");

	CVAR_REGISTER (&init_statsme_version);
	CVAR_REGISTER (&init_sm_flood);
	CVAR_REGISTER (&init_sm_rankcmd);
	CVAR_REGISTER (&init_sm_statsmecmd);
	CVAR_REGISTER (&init_sm_statscmd);
	CVAR_REGISTER (&init_sm_monsternum);
	CVAR_REGISTER (&init_sm_monsterfreq);
	CVAR_REGISTER (&init_sm_menupassword);
	CVAR_REGISTER (&init_sm_killsforrank);
	CVAR_REGISTER (&init_sm_resetrank);
	CVAR_REGISTER (&init_sm_latlogfreq);
	CVAR_REGISTER (&init_sm_ranklogfile);
	CVAR_REGISTER (&init_sm_resetonrestart);
	CVAR_REGISTER (&init_sm_logmenuaction);
	CVAR_REGISTER (&init_sm_switchinfo);
	CVAR_REGISTER (&init_sm_refresh);
	CVAR_REGISTER (&init_sm_rankupdate);
	CVAR_REGISTER (&init_sm_rankbots);
	CVAR_REGISTER (&init_sm_addonlogformat);
	CVAR_REGISTER (&init_sm_storebyauth);
	CVAR_REGISTER (&init_sm_punishnocd);
	CVAR_REGISTER (&init_sm_enabled);
	CVAR_REGISTER (&init_sm_pingspike);
	CVAR_REGISTER (&init_sm_smarthud);

	CVAR_REGISTER (&init_sm_htmlbgcolor);
	CVAR_REGISTER (&init_sm_htmlfgcolor);
	CVAR_REGISTER (&init_sm_htmlfont);
	CVAR_REGISTER (&init_sm_htmlvgui2);
	
	statsme_version=CVAR_GET_POINTER("statsme_version");
	sm_rankbots=CVAR_GET_POINTER("sm_rankbots");
	sm_rankupdate=CVAR_GET_POINTER("sm_rankupdate");
	sm_refresh=CVAR_GET_POINTER("sm_refresh");
	sm_logmenuaction=CVAR_GET_POINTER("sm_logmenuaction");
	sm_switchinfo=CVAR_GET_POINTER("sm_switchinfo");
	sm_resetonrestart=CVAR_GET_POINTER("sm_resetonrestart");
	sm_ranklogfile=CVAR_GET_POINTER("sm_ranklogfile");
	sm_resetrank=CVAR_GET_POINTER("sm_resetrank");
	sm_rankcmd=CVAR_GET_POINTER("sm_rankcmd");
	sm_statsmecmd=CVAR_GET_POINTER("sm_statsmecmd");
	sm_statscmd=CVAR_GET_POINTER("sm_statscmd");
	sm_killsforrank=CVAR_GET_POINTER("sm_killsforrank");
	sm_menupassword=CVAR_GET_POINTER("sm_menupassword");
	sm_monsternum=CVAR_GET_POINTER("sm_monsternum");
	sm_monsterfreq=CVAR_GET_POINTER("sm_monsterfreq");
	sm_latlogfreq=CVAR_GET_POINTER("sm_latlogfreq");
	sm_flood=CVAR_GET_POINTER("sm_flood");
	sm_addonlogformat=CVAR_GET_POINTER("sm_addonlogformat");
	sm_storebyauth=CVAR_GET_POINTER("sm_storebyauth");
	sm_punishnocd=CVAR_GET_POINTER("sm_punishnocd");
	sm_enabled=CVAR_GET_POINTER("sm_enabled");
	sm_pingspike=CVAR_GET_POINTER("sm_pingspike");
	sm_smarthud=CVAR_GET_POINTER("sm_smarthud");


	sm_htmlbgcolor=CVAR_GET_POINTER("sm_htmlbgcolor");
	sm_htmlfgcolor=CVAR_GET_POINTER("sm_htmlfgcolor");
	sm_htmlfont=CVAR_GET_POINTER("sm_htmlfont");
	sm_htmlvgui2=CVAR_GET_POINTER("sm_htmlvgui2");


	memset(parseMsg,' ',sizeof(parseMsg));
	time(&sm.last_reset); //this version is loaded for the first time


	char game_dir[256];
	// find the directory name of the currently running MOD...
	GET_GAME_DIR(game_dir);
	printf("%s\n",game_dir);

    if (strlen(game_dir) <= 0) // Error getting directory name!
                LOG_MESSAGE(PLID, "StatsMe - Error determining MOD directory name!" );

//   strcpy(mod_name, &game_dir[++pos]);
    strcpy(sm.mod_name, game_dir);

    struct mod_info_t
    {
		char name[16];
		MOD_TYPE mod_id;
		mod_settings_t set;
	} pSelect[] =
	{
		{"cstrike",MOD_CSTRIKE,{true}},
		{"czero",MOD_CSTRIKE,{true}},
		{"dod",MOD_DOD,{true}},		
		{"tfc",MOD_TFC,{false}},
		{"frontline",MOD_FLF,{false}},
		{"dmc",MOD_DMC,{false}},
		{"vs",MOD_VS,{false}},
		{"firearms",MOD_FIREARMS,{false}},
		{"action",MOD_ACTION,{false}},
		{"valve",MOD_VALVE,{false}},
		{"gearbox",MOD_GEARBOX,{false}},
		{"ricochet",MOD_RICOCHET,{false}},//<- doesn't work :/
		{"ns",MOD_NS,{false}},
		{"nsp",MOD_NSP,{false}}, // <- NS 3.0 beta, probably temporary modname
		{"ios",MOD_IOS,{false}},
		{"dcrisis",MOD_DCRISIS,{false}},
		{"",MOD_UNKNOW,{false}}
	};

	int select_index = 0;
	while (*pSelect[select_index].name && strcmpi(sm.mod_name, pSelect[select_index].name))
		select_index++;

	sm.mod_id = pSelect[select_index].mod_id;
	sm.mod_set = pSelect[select_index].set;

	LOG_MESSAGE(PLID, "found mod: %s",pSelect[select_index].name);

	//UTIL_GetModName(sm.mod_name, &sm.mod_id);// find out what mod we are running

#ifdef DEBUG_OPTION
	CVAR_REGISTER (&init_sm_debug);
	sm_debug=CVAR_GET_POINTER("sm_debug");
	strcpy(sm.debug_name, UTIL_Pathname("%s/sm_debug_%s.txt",sm.mod_name,sm.mod_name)); // make debug filename for sm_debug cvar
#endif

}
