/*
Copyright 2002 - 2004 UnitedAdmins
Project originally created by OLO (http://olo.counter-strike.pl)

This file is part of StatsMe.

   StatsMe is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   StatsMe is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with StatsMe; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   A copy of the GNU General Public License is available in a file called COPYING.
   See README for more information.

*/

/* $Id: statsme_dod.cpp,v 1.20 2004/03/18 17:11:23 punisher Exp $ */

#include <extdll.h>			// always
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <cbase.h>			// DMG bits
#include "statsme.h"	// me

//struct keeping names and indexes for weapons

// DoD 1.0 Weapon workaround
wpn_sel_t weapon_select_dod[] = {
	{WEAPON_DOD_NONE,"none"},
	{WEAPON_DOD_AMERKNIFE,"amerknife"},
	{WEAPON_DOD_GERKNIFE,"gerknife"},
	{WEAPON_DOD_COLT,"colt"},
	{WEAPON_DOD_LUGER,"luger"},
	{WEAPON_DOD_GARAND,"garand"},
	{WEAPON_DOD_SCOPEDKAR,"scopedkar"},
	{WEAPON_DOD_THOMPSON,"thompson"},
	{WEAPON_DOD_MP44,"mp44"},
	{WEAPON_DOD_SPRING,"spring"},
	{WEAPON_DOD_KAR,"kar"},
	{WEAPON_DOD_BAR,"bar"},
	{WEAPON_DOD_MP40,"mp40"},
	{WEAPON_DOD_HANDGRENADE,"handgrenade"},
	{WEAPON_DOD_STICKGRENADE,"stickgrenade"},
	{WEAPON_DOD_STICKGRENADE_EX,"stickgrenade_ex"},
	{WEAPON_DOD_HANDGRENADE_EX,"handgrenade_es"},
	{WEAPON_DOD_MG42,"mg42"},
	{WEAPON_DOD_30CAL,"30cal"},
	{WEAPON_DOD_SPADE,"spade"},
	{WEAPON_DOD_M1CARBINE,"m1carbine"},
	{WEAPON_DOD_MG34,"mg34"},
	{WEAPON_DOD_GREASEGUN,"greasegun"},
	{WEAPON_DOD_FG42,"fg42"},
	{WEAPON_DOD_K43,"k43"},
	{WEAPON_DOD_ENFIELD,"enfield"},
	{WEAPON_DOD_STEN,"sten"},
	{WEAPON_DOD_BREN,"bren"},
	{WEAPON_DOD_WEBLEY,"webley"},
	{WEAPON_DOD_BAZOOKA,"bazooka"},
	{WEAPON_DOD_PSCHRECK,"pschreck"},
	{WEAPON_DOD_PIAT,"piat"}
};

/*void EmitSound_DOD(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int fFlags, int pitch) {
	
	// DoD doesn't emite any sound on slashing, only on hits ( so our acc. will be always 100% )
	
	//weapons/knife: _hit1, _hit2, _hit3, _hit4, _hitwall1, _slash1, _slash2, _stab, _deploy (last to skip)
	//const char* name = STRING(entity->v.netname);
	//if (*name)
	//	SERVER_PRINT(UTIL_VarArgs("SOUND: %s FROM: %s\n",sample,name));
	//if (sample[0]=='w'&&sample[1]=='e'&&sample[8]=='k'&&sample[9]=='n'&&sample[14]!='d')
	//{
	//	player_t*pPlayer = GET_PLAYER_POINTER(entity); //knife hits on wall and slash
	//	FireShot(pPlayer, pPlayer->wpnid);
	//}

	RETURN_META(MRES_IGNORED);
}*/

void SetModel_DOD(edict_t *e, const char *m){
	// "models/w_stick" "models/w_grenade"
	if( e->v.owner && (m[7]=='w'&&m[8]=='_'&&((m[9]=='g'&&m[10]=='r')||(m[9]=='s'&&m[10]=='t')))) {
		player_t*pPlayer = GET_PLAYER_POINTER(e->v.owner);
		int weapon = ( pPlayer->team_name[1]=='x' ) ? 14 : 13;
		PutGrenade(e, 5.16 , weapon , pPlayer);
		FireShot(pPlayer, weapon);
	}
	RETURN_META(MRES_IGNORED);
}

void Client_Bandaging_DOD(void* mValue)
{
	// ...
}

void Client_Bleeding_DOD(void* mValue)
{
	edict_t* enemy = NULL;

	if ( *(int*)mValue && ((enemy = mPlayer->pEdict->v.dmg_inflictor) != NULL)  ) {
		grenades_t* grenade = NULL;
		player_t*  killer = NULL;
		int weapon = 0;
		int aiming = 0;
		if (enemy->v.flags & player_bits) { // player
			killer = GET_PLAYER_POINTER(enemy);
			weapon = killer->weapon->id;
			aiming = killer->aiming_at;
		}
		else if( ( grenade = FindGrenade(enemy) ) != NULL ) { //grenade
			killer = grenade->pPlayer;
			weapon = grenade->index;
		}
		else
			return;

		mPlayer->bleeding = killer;
		mPlayer->bleeding_weapon = weapon;
		mPlayer->bleeding_aiming = aiming;
	}
	else {
		mPlayer->bleeding = NULL;
	}
}

// message about death (top-right corner)
void Client_DeathMsg_DOD(void* mValue)
{	
	static float last_call = 0;

	if (last_call == gpGlobals->time) // prevent from calling the same function multiple times
		return;

	static player_t *killer;
	static player_t *victim;
	static int kid;
	static int vid;
	
	static int weapon_id;

	switch (mState++){
	case 0:
		kid = *(int*)mValue;
		killer = sm.killer = (kid > 0 && kid < 33) ? GET_PLAYER_POINTER_I(kid) : NULL;
		break;
	case 1:
		vid = *(int*)mValue;
		victim = sm.victim = (vid > 0 && vid < 33) ? GET_PLAYER_POINTER_I(vid) : NULL;
		break;
	case 2:

		last_call = gpGlobals->time; // prevent from calling the same function multiple times

		if ( !killer || !victim ) 
			break;

		int aiming = killer->aiming_at;
		weapon_id = *(int*)mValue;
		const char* sWpn = weapon_select_dod[weapon_id].name;

		if ( killer->index == victim->index )	{


			// enforce penalty for suicides...
			victim->pRnd_stats->deaths++;
			victim->pGm_stats->deaths++;
			victim->pRnd_stats->sk++;
			victim->pGm_stats->sk++;

			if ( victim->bleeding )	{
				killer = victim->bleeding;
				kid = killer->index;
				aiming = victim->bleeding_aiming;
				sWpn = weapon_select_dod[victim->bleeding_weapon].name;
			}		
			else
				break;
		}

		int hs = (aiming == 1) ? 1 : 0;

		if (sWpn[0]=='g'&&sWpn[1]=='r'&&sWpn[2]=='e') //this is "grenade"
			sWpn = "handgrenade";
		else if (sWpn[0]=='s'&&sWpn[1]=='t'&&sWpn[2]=='i')
			sWpn = "stickgrenade";
		
		strcpy(killer->pPpl_stats[vid].name, weapon_select_dod[weapon_id].name); //save name of weapon from which you have been killed
		strcpy(victim->pAPpl_stats[kid].name, weapon_select_dod[weapon_id].name);
		killer->custom = &killer->pPpl_stats[vid];
		victim->custom = &victim->pPpl_stats[kid];
		victim->killer = killer;
		killer->victim = victim;
		victim->damage_deathmsg = hs + 1; //deathmessage with headshot
		FireKill(victim, killer, weapon_id, hs , (killer->team_index == victim->team_index) );
	}
}

// message gets sent when the players health changes
void Client_Health_DOD(void* mValue)
{
	int health = *(int*)mValue;
	int damage = mPlayer->health - health;
	mPlayer->health = health;
	if ( damage <= 0 ) return;
	edict_t* enemy = NULL;
	player_t* killer = NULL;
	grenades_t* grenade;
	int weapon = 0;
	int aiming = 0;

	if ( (enemy = mPlayer->pEdict->v.dmg_inflictor) == NULL )
		return; //no enemy
	
	if (enemy->v.flags & player_bits) { // player
		if ( enemy == mPlayer->pEdict && mPlayer->bleeding )	{
			killer = mPlayer->bleeding;
			weapon = mPlayer->bleeding_weapon;
			aiming = mPlayer->bleeding_aiming;
		}
		else {
			killer = GET_PLAYER_POINTER(enemy);
			weapon = killer->weapon->id;
			aiming = killer->aiming_at;
		}
	}
	else if( ( grenade = FindGrenade(enemy) ) != NULL ) { //grenade
		killer = grenade->pPlayer;
		weapon = grenade->index;
	}
	else {//no grenade nor player so skip it
		return; 
	}

	if (killer) {//if this is a player
		// this is for SM_Damage_CS
		mPlayer->damage_aim = killer->aiming_at;
		mPlayer->damage_attacker = killer;
		mPlayer->damage_damage = damage;
		mPlayer->damage_weapon = weapon;
		// end

		if (weapon > 0 && weapon < 3) // german and american knife
			FireShot(killer, weapon);

		FireHit(mPlayer,killer, weapon, damage, aiming);
		// send SM_DeathMsg or SM_Damage and then SM_DeathMsg
		endfunction = mPlayer->damage_deathmsg ? Client_SM_DeathMsg : Client_SM_Damage;
		sm.killer = killer;
		sm.victim = mPlayer;
	}	
}

void Client_ScreenFade_DOD(void* mValue) // Fix for SturmBOT
{
	 if (!mPlayer->ingame) {
		edict_t* pEntity = INDEXENT(mPlayerIndex);
		PlayerConnect( pEntity , STRING(pEntity->v.netname), "127.0.0.1:27005" );
		PlayerPutInServer( mPlayer );
	}  // yeah works
}

/* //msg send when text is send to client or all players
void Client_TextMsg_DOD(void* mValue) 
{
 // for later use
}
*/

// msg send on player respawn/spawn
void Client_ResetHUD_End_DOD(void* mValue)
{
	if ( sm_rankupdate->value == 2 && ( !mPlayer->bot || sm_rankbots->value ) ) {
		ScorePlayerInRank( STRING(mPlayer->pEdict->v.netname), mPlayer->pRank, mPlayer->pRnd_stats );
		memset(&mPlayer->aRnd_stats, 0 ,sizeof(stat_t));
	}
	memset(mPlayer->aPpl_stats, 0 ,sizeof(stat_t)*33);
	memset(mPlayer->aAPpl_stats, 0 ,sizeof(stat_t)*33);
	mPlayer->killer = NULL;
	mPlayer->victim = NULL;
	mPlayer->bleeding = NULL;
	mPlayer->damage_deathmsg = 0;
}

// msg send to update current status about weapon - ammo, active weapon etc
void Client_CurWeapon_DOD(void* mValue)
{
	static int iState;
	static int iId;

	switch (mState++){
	case 0:	
		iState = *(int*)mValue;
		break;
	case 1:
		if (!iState)
			break;//active weapon have iState set to 1
			
		iId = *(int*)mValue; // weapon ID
		break;
	case 2:
		if (!iState) break;
		
		int iClip = *(int*)mValue;
		
		if (iClip > -1 && iClip < mPlayer->pWpn_stats[iId].clip) 
			FireShot(mPlayer, iId);
		
		mPlayer->weapon = &mPlayer->pWpn_stats[iId];
		mPlayer->weapon->id = iId;
		strcpy(mPlayer->weapon->name, weapon_select_dod[iId].name); //save name of this weapon
		mPlayer->pWpn_stats[iId].clip = iClip;
	}
}
