/*
Copyright 2002 - 2004 UnitedAdmins
Project originally created by OLO (http://olo.counter-strike.pl)

This file is part of StatsMe.

   StatsMe is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   StatsMe is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with StatsMe; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   A copy of the GNU General Public License is available in a file called COPYING.
   See README for more information.

*/

/* $Id: statsme_global.cpp,v 1.13 2004/06/16 14:32:05 punisher Exp $ */

#include <extdll.h>			// always
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <cbase.h>			// DMG bits
#include "statsme.h"	// me

int player_bits = (FL_CLIENT | FL_FAKECLIENT);

void Client_SM_Damage(void* mValue)
{
	player_t* attacker = sm.killer = mPlayer->damage_attacker;
	player_t* victim = sm.victim = mPlayer;

	attacker->custom = &attacker->pPpl_stats[victim->index];
	victim->custom = &victim->pPpl_stats[attacker->index];

	PARSE_MESSAGE_BEGIN( SM_DAMAGE, victim , victim->index );
		PARSE_WRITE_BYTE( attacker->index );	// index of attacker
		PARSE_WRITE_BYTE( victim->damage_damage ); // damage
		PARSE_WRITE_BYTE( victim->damage_aim ); // where enemy was aiming
		PARSE_WRITE_BYTE( victim->damage_weapon ); // id of weapon
		PARSE_WRITE_BYTE( (victim->team_index == attacker->team_index) ? 1 : 0 ); // teamattack?
	PARSE_MESSAGE_END();
}

// Fix for Counter-Strike where DeathMsg is sent before Damage
// This generates event but catched only by StatsMe, it's not send to players
void Client_SM_DeathMsg(void* mValue)
{

	if (sm.mod_id != MOD_TFC)
		Client_SM_Damage(NULL);
	player_t* killer = sm.killer = mPlayer->killer;
	player_t* victim = sm.victim = mPlayer;

	killer->custom = &killer->pPpl_stats[victim->index];
	victim->custom = &victim->pPpl_stats[killer->index];

	PARSE_MESSAGE_BEGIN( SM_DEATHMSG );
		PARSE_WRITE_BYTE( killer->index );	// the killer
		PARSE_WRITE_BYTE( victim->index ); // the victim
		PARSE_WRITE_BYTE( (victim->damage_deathmsg == 2) ? 1 : 0 ); // headshot?
		PARSE_WRITE_STRING( killer->pPpl_stats[victim->index].name ); // weapon
		PARSE_WRITE_BYTE( (victim->team_index == killer->team_index) ? 1 : 0 ); // teamkilling?
	PARSE_MESSAGE_END();



	if ( sm.mod_id == MOD_CSTRIKE )
	{
		// LastMan message is generated here
		player_t* pPlayer;
		int alive_player_count = 0,last_alive_player = 0;
		for ( int i = 1; i <= gpGlobals->maxClients; ++i )
		{
			pPlayer = GET_PLAYER_POINTER_I(i);
			if (pPlayer->ingame && (pPlayer->pEdict->v.deadflag == DEAD_NO) && pPlayer->team_index == mPlayer->team_index)
			{
				last_alive_player = i;
				alive_player_count++;
			}
		}
		if (alive_player_count == 1)
		{
			pPlayer = GET_PLAYER_POINTER_I(last_alive_player); 
			PARSE_MESSAGE_BEGIN( SM_LASTMAN );
				PARSE_WRITE_BYTE( pPlayer->index );
				PARSE_WRITE_BYTE( pPlayer->team_index );
				PARSE_WRITE_STRING( pPlayer->name );
			PARSE_MESSAGE_END();
		}
	}
}
