/*
Copyright 2002 - 2004 UnitedAdmins
Project originally created by OLO (http://olo.counter-strike.pl)

This file is part of StatsMe.

   StatsMe is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   StatsMe is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with StatsMe; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   A copy of the GNU General Public License is available in a file called COPYING.
   See README for more information.

*/

/* $Id: statsme_vars.cpp,v 1.16 2004/06/16 10:47:34 punisher Exp $ */

#include <extdll.h>			// always

#include <api_info.h>		// api_info_t, etc
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include "statsme.h"	// me
#include <ctype.h>

enum {
 S_NAME = -128,
 S_UID,
 S_AID,
 S_DEATHS,
 S_VICTIMS,
 S_ATTACKERS,
 S_HEALTH,
 S_ARMOR,
 S_MONEY,
 S_PING,
 S_SPIKE,
 S_TIME,
 S_WONID,
 S_TEAM,
 S_ALIVE,
 S_MODE,
 S_MAXPPL,
 S_GMTIME,
 S_KILLS,
 S_DAMAGE,
 S_SHOTS,
 S_HITS,
 S_CLIP,
 S_AMMO,
 S_SCORE,
 S_HEAD,
 S_CHEST,
 S_STOMACH,
 S_LEFTARM,
 S_RIGHTARM,
 S_LEFTLEG,
 S_RIGHTLEG,
 S_MKILL,
 S_MDISR,
 S_MACC,
 S_CURRENTMAP,
 S_TIMELEFT,
 S_THETIME,
 S_WEEKDAY,
 S_WDAY,
 S_PPLNUM,
 S_RANKNUM,
 S_MIN,
 S_SEC,
 S_HOUR,
 S_DAY,
 S_MONTH,
 S_MON,
 S_YEAR,
 S_SKIP,
 S_TKS,
 S_HS,
 S_ACC,
 S_EFF,
 S_ID,
 S_TXT,
 S_IP,
 S_RD,
 S_GM,
 S_PLAYER,
 S_MOD,
 S_ACTION,
 S_TM_RD,
 S_TM_GM,
 S_KILLER,
 S_VICTIM,
 S_WEAPON,
 S_VALUEX,
 S_RANK,
 S_BOT,
 S_POSITION,
 S_INFO,
 S_DIST,
 S_T1RND,
 S_T1GM,
 S_T2RND,
 S_T2GM,
 S_VAR,
 S_CODE,
 S_CVAR,
 S_WORD,
 S_RANDOM,
 S_CEND,
 S_CBEGIN,
 S_CQUEST,
 S_CEQUAL,
 S_CELSE,
 S_CIN,
 S_CLESS,
 S_CMORE,
 S_CNOT,
 S_CMUL,
 S_CDIV,
 S_CSUB,
 S_CADD,
 S_CSET,
 S_CUNSET,
 S_CEXIT,
 S_CVALUE,
 S_TEAMCOUNT,
 S_TEAMINDEX,
 S_SELFKILLS,
 S_POINTS,
 S_PSRANK,
 S_PSKILLS,
 S_PSDEATHS,
 S_PSKPD,
 S_PSKPM,
 S_PSPOINTS,
 S_PLAYTIME,
 S_USERDEF,
 S_POSX,
 S_POSY,
 S_POSZ

};

struct pcode_t {
	char name[16];
	char value;
} pcode[] = { 
	{"name",S_NAME},
	{"uid", S_UID},
	{"aid", S_AID},
	{"deaths", S_DEATHS},
	{"victims", S_VICTIMS},
	{"attackers", S_ATTACKERS},
	{"health", S_HEALTH},
	{"armor", S_ARMOR},
	{"money", S_MONEY},
	{"ping", S_PING},
	{"spikes", S_SPIKE},
	{"time", S_TIME},
	{"wonid", S_WONID},
	{"team", S_TEAM},
	{"team_index", S_TEAMINDEX},
	{"alive", S_ALIVE},
	{"sm_mode", S_MODE},
	{"maxplayers", S_MAXPPL},
	{"gmtime", S_GMTIME},
	{"kills", S_KILLS},
	{"damage", S_DAMAGE},
	{"shots", S_SHOTS},
	{"hits", S_HITS},
	{"mod", S_MOD},
	{"clip", S_CLIP},
	{"ammo", S_AMMO},
	{"score", S_SCORE},
	{"dist", S_DIST},
	{"head", S_HEAD},
	{"chest", S_CHEST},
	{"stomach", S_STOMACH},
	{"leftarm", S_LEFTARM},
	{"rightarm", S_RIGHTARM},
	{"leftleg", S_LEFTLEG},
	{"rightleg", S_RIGHTLEG},
	{"mkill", S_MKILL},
	{"mdisr", S_MDISR},
	{"macc", S_MACC},
	{"currentmap", S_CURRENTMAP},
	{"timeleft", S_TIMELEFT},
	{"thetime", S_THETIME},
	{"weekday", S_WEEKDAY},
	{"wday", S_WDAY},
	{"playersnum", S_PPLNUM},
	{"ranknum", S_RANKNUM},
	{"min", S_MIN},
	{"sec", S_SEC},
	{"hour", S_HOUR},
	{"day", S_DAY},
	{"mon", S_MON},
	{"month", S_MONTH},
	{"year", S_YEAR},
	{"tks", S_TKS},
	{"hs", S_HS},
	{"acc", S_ACC},
	{"eff", S_EFF},
	{"id", S_ID},
	{"txt", S_TXT},
	{"ip", S_IP},
	{"rd", S_RD},
	{"gm", S_GM},
	{"p", S_PLAYER},
	{"trd", S_TM_RD},
	{"tgm", S_TM_GM},
	{"k", S_KILLER},
	{"v", S_VICTIM},
	{"w", S_WEAPON},
	{"rk", S_RANK},
	{"st", S_ACTION},
	{"a", S_ACTION},
	{"bot", S_BOT},
	{"pos", S_POSITION},
	{"I", S_INFO},
	{"t1rd", S_T1RND},
	{"t1gm", S_T1GM},
	{"t2rd", S_T2RND},
	{"t2gm", S_T2GM},
	{"%", S_VAR},
	{"#", S_CODE},
	{"C", S_CVAR},
	{"W", S_WORD},
	{"R", S_RANDOM},
	{"teamcount", S_TEAMCOUNT},
	{"sk", S_SELFKILLS},
	{"points", S_POINTS},
	{"psrank", S_PSRANK},
	{"pskills", S_PSKILLS},
	{"psdeaths", S_PSDEATHS},
	{"pskpd", S_PSKPD},
	{"pskpm", S_PSKPM},
	{"pspoints", S_PSPOINTS},
	{"playtime", S_PLAYTIME},
	{"user", S_USERDEF},
	{"posx", S_POSX},
	{"posy", S_POSY},
	{"posz", S_POSZ},
	{"",0} // terminator
};

// exception for coding the names
bool smv_pre_ex(const char* src,const char* a,char code,char* dest)
{
	int len = strlen( a );
	const char* v = src + len;
	if ( strncmp( src, a, len ) || !atoi( v ) )
		return false;
	*dest++ = code;
	if ( *(v + 1) ) {
		*dest++ = *v;
		*dest++ = *(v + 1);
		*dest = 0;
	}
	else {
		*dest++ = *v;
		*dest = 0;
	}
	return true;	
}

// codes the names
// codes the names
int smv_pre_code(char** dest,char* src)
{
	char var[4];
	char* pv = var;
	char* len = *dest;
	bool result = false;

	pcode_t* i = pcode;
	while ( *i->name ) {
		if ( result = ( strcmp(src, i->name ) == 0 ) ){
			*pv++ = i->value;
			*pv = 0;
			break;
		}
		++i;
	}

	if ( !result ) {
		result = (smv_pre_ex(src,"p",S_PLAYER,var)||smv_pre_ex(src,"a",S_ACTION,var)||
			smv_pre_ex(src,"w",S_WEAPON,var)||smv_pre_ex(src,"V",S_VALUEX,var)||
			smv_pre_ex(src,"sm_mode",S_MODE,var));
	}

	pv = result ? var : src;
	while (*pv) *(*dest)++ = *pv++;

	return *dest - len;
}


// Possible types combinations for { } expressions
//	1 = a, 2 = %.a, 4 = c, 8 = d, 16 = e, 32 = #.a ... , 64 = #.a
//	1 or 3		{ a }
//	5			{ a + c }
//	7			{ %.a + c }
//	9 or 11		{ a ? d }
//	25 or 27	{ a ? d + e }
//	13 or 15	{ a = c ? d }
//	29 or 31	{ a = c ? d : e }
//  37			{ #.a = c }
//  97			{ #.a }

// preprocessor for { } expressions
// format {abcdef[c][d][e][f]}
// a is a type of expresion
// b is an operation (if any)
// c, d, e, f are the length of each parameter
int smv_pre_var(char** dest, const char** src)
{
	char var[32], *e, *r = *dest;
	*(*dest)++ = S_CBEGIN;
	char* pcode = *dest;
	*(pcode)=*(pcode+1)=*(pcode+2)=*(pcode+3)=*(pcode+4)=*(pcode+5)=1;
	char *begin = ((*dest) += 6), *plen = pcode + 2;
	int oper = 1, c, type = 1;
	while( *(*src) != '}' ) {
		c = *(*src);
		if ( c == '{' )	{
			(*plen) += smv_pre_var(&(*dest),&(++(*src)));
			continue;
		}
		if ( (type & 32) && (oper == S_CEQUAL) ) {
			if ( c == '\\' ) {
				switch( *((*src) + 1) ){
				case '{': case '}': case '?': case '\\': c = *(++(*src)); break;
				case '\'': c = '\"'; (*src)++; break;
				case 'n': c = '\n'; (*src)++; break;
				}
			}
		}
		else if ( type & 24 ) {
			if ( c == '\\' ) {
				switch( *((*src) + 1) ){
				case '{': case '}': case '$': case '\\': case '#': case ':': c = *(++(*src)); break;
				case '\'': c = '\"'; (*src)++; break;
				case 'n': c = '\n'; (*src)++; break;
				}
			}
			else {
				switch( c ){
				case ':':
					if (!(type & 16)) {
						type |= 16;
						plen = pcode + 5;
						(*src)++;
					} continue;
				case '#': c = S_CEXIT; break;
				case '$': c = S_CVALUE; break;
				}
			}
		}
		else if ( type & 4 ) {
			if ( c == '\\') {
				switch( *((*src) + 1) ){
				case '{': case '}': case '\\': case '?': c = *(++(*src)); break;
				}
			}
			else if ( c == '?') {
				type |= 8;
				plen = pcode + 4;
				(*src)++;
				continue;
			}
		}
		else if ( type & 1 ) {
			for(e = var; (isalpha(c)||isdigit(c)||c=='_'||c=='%'||c=='#'); c = *(*src))
				*e++ = *(*src)++;
			*e = 0;
			(*plen) += smv_pre_code(&(*dest),var);
			if ( *begin == S_VAR )	
				type |= 2;
			else if (  *begin == S_CODE )
				type |= 32;
			c = *(*src);
			switch ( c ){
			case '{':  case '}': continue;
			case '?': (*src)++;	type |= 8; plen = pcode + 4; continue;
			case '=': oper = S_CEQUAL; (*src)++;	type |= 4; plen = pcode + 3; continue;
			case '&': oper = S_CIN;	(*src)++;	type |= 4; plen = pcode + 3; continue;
			case '<': oper = S_CLESS;(*src)++;type |= 4; plen = pcode + 3; continue;
			case '>': oper = S_CMORE; (*src)++;	type |= 4; plen = pcode + 3; continue;
			case '!': oper = S_CNOT; (*src)++;	type |= 4; plen = pcode + 3; continue;
			case '*': oper = S_CMUL; (*src)++;	type |= 4; plen = pcode + 3; continue;
			case '/': oper = S_CDIV; (*src)++;	type |= 4; plen = pcode + 3; continue;
			case '-': oper = S_CSUB; (*src)++;	type |= 4; plen = pcode + 3; continue;
			case '+': oper = S_CADD; (*src)++;type |= 4; plen = pcode + 3; continue;
			case '|': oper = S_CSET; (*src)++;	type |= 4; plen = pcode + 3; continue;
			case '~': oper = S_CUNSET;(*src)++;type |= 4; plen = pcode + 3; continue;
			}
		}

		*(*dest)++ = c;
		(*src)++;
		(*plen)++;
	}
	*(*dest)++ = S_CEND;
	(*src)++;
	if (type!=7) type &= ~2;// reduce types
	if ((type & 32)&&oper!=S_CEQUAL) type |= 64;
	*pcode = type;
	*(pcode+1) = oper;
	return *dest - r;
}

// general preprocessor
char* smv_pre_proc(const char* src)
{
	static char pcode[2][512];
	static int i = 0; i = i ? 0 : 1;
	char* dest = pcode[i];
	while (*src){
		if ( *src == '{' ) {
			smv_pre_var(&dest,&(++src));
			continue;
		}
		else if ( *src == '\\' ) {
			switch ( *(src+1) ) {
			case 'n': 
				*dest++ = '\n'; src += 2; continue;
			case '\'': 
				*dest++ = '"'; src += 2; continue;
			case '\\': case '{': case '}':
				*dest++ = *(src+1); src += 2; continue;
			}
		}
		*dest++ = *src++;
	}
	*dest = 0;
	return pcode[i];
}

// returns pointer to sm_var
myvar_t* findVar(myvar_t** b, const char* name)
{
	myvar_t*s = *b;

	while ( s ){
		if ( !strcmp(s->name,name) )
			break;
		s = s->next;
	}

	if ( !s ) { // not found so init it as for the first time
		myvar_t*a=new myvar_t;
		a->name = new char[strlen(name)+1];
		strcpy(a->name,name);
		a->len = 32;
		a->string = new char[33];
		strcpy(a->string,"0");
		a->value = 0;
		a->next = *b;
		*b = s = a;
	}

	return s;
}

// does operation on sm_var and updates its value
void doVar(myvar_t** b,const char* name, int op, const char* value, int len){
	if (UTIL_IsDigit( value )) {
		myvar_t* a = findVar(&(*b),name);
		switch(op) {
		case S_CEQUAL :a->value = atof(value);break;
		case S_CADD:a->value += atof(value);break;
		case S_CSUB:a->value -= atof(value);break;
		case S_CMUL:a->value *= atof(value);break;
		case S_CDIV:a->value /= atof(value);break;
		case S_CSET:a->value = (int)a->value | atoi(value);break;
		case S_CUNSET:a->value = (int)a->value & ~atoi(value);break;
		}
		sprintf(a->string,ROUND_VALUE(a->value)?"%.2f":"%.0f",a->value);
	}
	else if ( op == S_CEQUAL ) {
		myvar_t* a = findVar(&(*b),name);
		a->value = 0;
		if (a->len < len) {
			delete[] a->string;
			a->string = new char[len + 1];
			a->len = len;
		}
		strcpy(a->string,value);
	}
	else if ( op == S_CADD ) {
		myvar_t* a = findVar(&(*b),name);
		a->value = 0;
		a->len += len;
		char* n = new char[a->len];
		strcpy(n,a->string);
		strcat(n,value);
		delete[] a->string;
		a->string = n;
	}
}

// does operation on values and fills with result
void doCalc(char** dest, const char* one, int op, const char* two){
	float var = 0;
	switch(op) {
	case S_CADD:var = atof(one) + atof(two);break;
	case S_CSUB:var = atof(one) - atof(two);break;
	case S_CMUL:var = atof(one) * atof(two);break;
	case S_CDIV:var = atof(one) / atof(two);break;
	case S_CSET:var = atoi(one) | atoi(two);break;
	case S_CUNSET:var = atoi(one) & ~atoi(two);break;
	}
	(*dest) += sprintf(*dest,ROUND_VALUE(var)?"%.2f":"%.0f",var);
}

// reads index from expressions like "p12.name"; in case of failur returns 0
int smv_getindex(const char** s, char e)
{
	int i = 0;
	
	if ( *(*s) == e ) {
		(*s)++;
	}
	else if (*((*s)+1) == e ){
		i = *(*s)++ - '0';
		(*s)++;
	}
	else if (*((*s)+2) == e ){
		i = (*(*s) - '0') * 10 + (*((*s)+1) - '0');
		(*s)+=2;
	}
	return i;
}

const char* smv_playervar(player_t *pPlayer, const char* src);

const char* smv_statsvar(stat_t* stats, const char* src)
{
	static char value[2][8];
	static int i = 0; i = i ? 0 : 1;
	int a;

	if (!stats)	*value[i]=0;
	else
		switch( *src ){
		case S_NAME: return stats->name;
		case S_KILLS: sprintf(value[i], "%d", stats->kills); break;
		case S_DEATHS: sprintf(value[i], "%d", stats->deaths); break;
		case S_SELFKILLS: sprintf(value[i], "%d", stats->sk); break;
		case S_DAMAGE: sprintf(value[i], "%d", stats->damage); break;
		case S_SHOTS: sprintf(value[i], "%d", stats->shots); break;
		case S_HITS: sprintf(value[i], "%d", stats->hits); break;
		case S_TKS: sprintf(value[i], "%d", stats->tks); break;
		case S_HS: sprintf(value[i], "%d", stats->hs); break;
		case S_CLIP: sprintf(value[i], "%d", stats->clip); break;
		case S_AMMO: sprintf(value[i], "%d", stats->ammo); break;
		case S_SCORE: sprintf(value[i], "%d", stats->score); break;
		case S_HEAD: sprintf(value[i], "%d", stats->hitgroup[HITGROUP_HEAD] ); break;
		case S_CHEST: sprintf(value[i], "%d", stats->hitgroup[HITGROUP_CHEST] ); break;
		case S_STOMACH: sprintf(value[i], "%d", stats->hitgroup[HITGROUP_STOMACH] ); break;
		case S_LEFTARM: sprintf(value[i], "%d", stats->hitgroup[HITGROUP_LEFTARM] ); break;
		case S_RIGHTARM: sprintf(value[i], "%d", stats->hitgroup[HITGROUP_RIGHTARM] ); break;
		case S_LEFTLEG: sprintf(value[i], "%d", stats->hitgroup[HITGROUP_LEFTLEG] ); break;
		case S_RIGHTLEG: sprintf(value[i], "%d", stats->hitgroup[HITGROUP_RIGHTLEG] ); break;
		case S_ACC: sprintf(value[i], "%.2f", ACCURACY_FORMULA( stats->shots, stats->hits ) ); break;
		case S_EFF: sprintf(value[i], "%.2f", EFFEC_FORMULA( stats->kills, stats->deaths ) ); break;
		case S_ID: sprintf(value[i], "%d", stats->id); break;
		case S_TXT: return stats->text;
		case S_DIST: sprintf(value[i], "%.2f", stats->dist ); break;
		case S_POINTS: sprintf(value[i], "%.2f", stats->points ); break;
		case S_PLAYTIME: sprintf(value[i], "%d:%02d", (int)(stats->playtime / 60), (int)(stats->playtime % 60)  ); break;  
		case S_PSRANK: sprintf(value[i], "%d", stats->pstatsRank ); break;
		case S_PSKILLS: sprintf(value[i], "%d", stats->pstatsKills ); break;
		case S_PSDEATHS: sprintf(value[i], "%d", stats->pstatsDeaths ); break;
		case S_PSKPM: sprintf(value[i], "%.2f", stats->pstatsKPM ); break;
		case S_PSKPD: sprintf(value[i], "%.2f", stats->pstatsKPD ); break;
		case S_PSPOINTS: sprintf(value[i], "%d", stats->pstatsPoints ); break;
		case S_MKILL: return smv_playervar( stats->flags ? sm.gm_killer : sm.rnd_killer , src+2 );
		case S_MDISR: return smv_playervar( stats->flags ? sm.gm_disruptive : sm.rnd_disruptive , src+2 );
		case S_MACC: return smv_playervar( stats->flags ? sm.gm_accurate : sm.rnd_accurate , src+2 );

		case S_USERDEF:
			
			//debugmsg(src);

			a = smv_getindex(&(++src),'.');
			sprintf(value[i], "%d", stats->userdefined[a-1] );
			//if (a==0) debugmsg("zero");
			break;

		default: *value[i]=0;
		}

	return value[i];
}

const char* smv_playervar(player_t *pPlayer, const char* src)
{
	static char value[2][24];
	static int i = 0; i = i ? 0 : 1;

	if (!pPlayer)
		*value[i] =0;
	else
		switch( *src ){
		case S_ID: sprintf(value[i], "%d", pPlayer->index ); break;
		case S_UID: sprintf(value[i], "%d", GETPLAYERUSERID(pPlayer->pEdict) ); break;
		case S_NAME: return pPlayer->name;
		case S_RD: return smv_statsvar( pPlayer->pRnd_stats , src + 2 );
		case S_GM: return smv_statsvar( pPlayer->pGm_stats ,  src + 2  );
		case S_TM_RD: return smv_statsvar( &sm.roundstats[pPlayer->team_index],  src + 2  );
		case S_TM_GM: return smv_statsvar( &sm.gamestats[pPlayer->team_index], src + 2 );
		case S_KILLER: return smv_playervar( pPlayer->killer, src + 2 );
		case S_VICTIM: return smv_playervar( pPlayer->victim,src + 2  );
		case S_WEAPON: { 
			int a = smv_getindex(&(++src),'.'); 
			if (a>9) src++;
			return a ? smv_statsvar( &pPlayer->pWpn_stats[a],src) : smv_statsvar( pPlayer->weapon, src  );
		}
		case S_ACTION: {
			int a = smv_getindex(&(++src),'.');
			if (a>9)  src++;
			return a ? smv_statsvar( &pPlayer->pPpl_stats[a],src) : smv_statsvar( pPlayer->custom, src );
		}
		case S_RANK: return smv_statsvar( pPlayer->pRank ,src + 2  );
		case S_VICTIMS: return GetVictimsList(pPlayer);
		case S_ATTACKERS: return GetAttackersList(pPlayer);
		case S_HEALTH: sprintf(value[i], "%d", pPlayer->health );break;
		case S_ARMOR: sprintf(value[i], "%d", pPlayer->armor );break;
		case S_MONEY: sprintf(value[i], "%d", pPlayer->money );break;
		case S_SPIKE: sprintf(value[i], "%d", pPlayer->lat_spikes );break;
		case S_PING: sprintf(value[i], "%d", (pPlayer->lat_samples?(int)(pPlayer->lat_sum/pPlayer->lat_samples):0) );break;
		case S_TIME:{ int time = int(gpGlobals->time - pPlayer->play_time); sprintf(value[i], "%d:%02d", (int)(time / 60), (int)(time % 60)  ); }break;
		case S_WONID: sprintf(value[i], "%u", GETPLAYERWONID(pPlayer->pEdict) );break;
		case S_AID: return GETPLAYERAUTHID(pPlayer->pEdict);
		case S_TEAM: return pPlayer->team_name;
		case S_TEAMINDEX: sprintf(value[i], "%d", pPlayer->team_index);break;
		case S_ALIVE: return ((pPlayer->pEdict->v.deadflag==DEAD_NO) ? "1" : "0");
		case S_BOT: return (pPlayer->bot ? "1" : "0");
		case S_POSITION: sprintf(value[i], "%.2f %.2f %.2f",pPlayer->pEdict->v.origin.x, pPlayer->pEdict->v.origin.y,pPlayer->pEdict->v.origin.z);break;
		case S_POSX: sprintf(value[i], "%.2f", pPlayer->pEdict->v.origin.x);break;
		case S_POSY: sprintf(value[i], "%.2f", pPlayer->pEdict->v.origin.y);break;
		case S_POSZ: sprintf(value[i], "%.2f", pPlayer->pEdict->v.origin.z);break;
		case S_IP: return pPlayer->ip;
		case S_INFO: return ENTITY_KEYVALUE(pPlayer->pEdict,(char*)(src+2));
		case S_TEAMCOUNT: {
			player_t* temp_pl;
			int alive_ppl = 0;
			for ( int k = 1; k <= gpGlobals->maxClients; ++k )
			{
				temp_pl = GET_PLAYER_POINTER_I(k);
				if (temp_pl->ingame && (temp_pl->pEdict->v.deadflag == DEAD_NO) && temp_pl->team_index == pPlayer->team_index) { alive_ppl++; }
			} 
			sprintf ( value[i] , "%d" , alive_ppl );
		} break;
		default: *value[i]=0;
		}

	return value[i];
}

const char* smv_gamevar(const char* src)
{
	static char value[2][24];
	static int i = 0; i = i ? 0 : 1;
	
	switch( *src ){
	case S_PLAYER: {
		int a = smv_getindex(&(++src),'.');
		return a ? smv_playervar( GET_PLAYER_POINTER_I(a), src) : smv_playervar( sm.player, src );
	}
	case S_VAR: case S_CODE: return findVar(&sm_var,src+2)->string;
	case S_VICTIM: return smv_playervar( sm.victim, src + 2 );
	case S_KILLER: return smv_playervar( sm.killer, src + 2 );
	case S_MODE: sprintf(value[i], "%d", sm.sm_mode[smv_getindex(&(++src),0)]); break;
	case S_CVAR: return CVAR_GET_STRING(src + 2);
	case S_INFO: return LOCALINFO((char*)(src+2));
	case S_VALUEX: {
		int a = 0;
		if (( a = smv_getindex(&(++src),0)) ){ 
			if (parseVault[a].type == V_STRING)
				return parseVault[a].sValue;
			else if (parseVault[a].type == V_FLOAT)
				sprintf(value[i],"%.4f", parseVault[a].fValue);
			else if (parseVault[a].type == V_INTEGER)
				sprintf(value[i],"%d", parseVault[a].iValue);	
		}
		else if ((a = smv_getindex(&src,'.'))) { // don't move src pointer because it's already done above
			return smv_playervar( ((parseVault[a].type==V_STRING)?
				UTIL_GetPlayerByName(parseVault[a].sValue):
			GET_PLAYER_POINTER_I(parseVault[a].iValue)), src );
		}
	} break;
	case S_RANK: return smv_statsvar( sm.rank, src + 2 );
	case S_GM: return smv_statsvar( &sm.all_gamestats, src + 2 );
	case S_RD: return smv_statsvar( &sm.all_roundstats, src + 2 );
	case S_T1GM: return smv_statsvar( &sm.gamestats[sm.teamscore_id[0]] , src + 2 );
	case S_T2GM: return smv_statsvar( &sm.gamestats[sm.teamscore_id[1]] , src + 2 );
	case S_T1RND: return smv_statsvar( &sm.roundstats[sm.teamscore_id[0]] , src + 2 );
	case S_T2RND: return smv_statsvar( &sm.roundstats[sm.teamscore_id[1]] , src + 2 );
	case S_GMTIME: sprintf(value[i], "%.2f", gpGlobals->time ); break;
	case S_WORD: UTIL_IntToString( atoi( src + 2 ) , value[i]); break;
	case S_RANDOM: sprintf(value[i], "%d", (int)RANDOM_LONG(0, atoi(src+2) ) ); break;
	case S_MAXPPL: sprintf(value[i], "%d", gpGlobals->maxClients ); break;
	case S_CURRENTMAP: return STRING(gpGlobals->mapname);
	case S_TIMELEFT: {	if ( !mp_timelimit->value ) return "0";	int a = int(sm.game_timeleft + mp_timelimit->value * 60 - gpGlobals->time);	sprintf(value[i], "%d:%02d", a / 60,a % 60); } break;
	case S_PPLNUM: sprintf(value[i], "%d", UTIL_GetPlayersNumber()); break;
	case S_MOD: return sm.mod_name;
	case S_RANKNUM: sprintf(value[i], "%d", sm_rank_last ? sm_rank_last->id : 0 ); break;
	case S_THETIME:UTIL_GetSystemTime(value[i], sizeof(value), "%m/%d/%Y - %H:%M:%S"); break;
	case S_MIN: UTIL_GetSystemTime(value[i], sizeof(value), "%M"); break; 
	case S_HOUR: UTIL_GetSystemTime(value[i], sizeof(value), "%H"); break;
	case S_SEC: UTIL_GetSystemTime(value[i], sizeof(value), "%S"); break;
	case S_WEEKDAY: UTIL_GetSystemTime(value[i], sizeof(value), "%A"); break;
	case S_WDAY: UTIL_GetSystemTime(value[i], sizeof(value), "%a"); break;
	case S_MONTH: UTIL_GetSystemTime(value[i], sizeof(value), "%B"); break;
	case S_MON: UTIL_GetSystemTime(value[i], sizeof(value), "%b"); break;
	case S_DAY: UTIL_GetSystemTime(value[i], sizeof(value), "%d"); break;
	case S_YEAR: UTIL_GetSystemTime(value[i], sizeof(value), "%Y"); break;
	
	default: return src;
	}	
	
	return value[i];
}

bool smv_cond(const char* n, int oper, const char* v)
{
	if ( UTIL_IsDigit( n ) ) {
		switch ( oper )	{
		case S_CIN: return (atoi( n ) & UTIL_ReadFlags( v )) ? true : false;
		case S_CEQUAL: return (atof( n ) == atof( v )) ? true : false;
		case S_CNOT: return (atof( n ) != atof( v )) ? true : false;
		case S_CLESS: return (atof( n ) < atof( v )) ? true : false;
		case S_CMORE: return (atof( n ) > atof( v )) ? true : false;
		default: return atof( n ) ? true : false;
		}
	}
	else {
		switch (oper) {
		case S_CEQUAL: return (!strcmpi( n, v )) ? true : false;
		case S_CNOT: return (strcmpi( n, v )) ? true : false;
		case S_CIN: return (strstr( n, v )) ? true : false;
		case S_CLESS: return (strcmpi( n, v )<0) ? true : false;
		case S_CMORE: return (strcmpi( n, v )>0) ? true : false;
		default: return *n ? true : false;
		}
	}
}

bool smv_getvar(char** dest, const char** src);

bool smv_getans(char** dest, const char** src,const char* end)
{
	while (*src != end) {
		if ( *(*src) == S_CBEGIN ) {
			if (smv_getvar(&(*dest), &(++(*src))))
				return true;
			continue;
		}
		*(*dest)++ = *(*src)++;
	}
	*(*dest) = 0;
	return false;
}

// Fill with proper answer
bool smv_setarg(char** dest, const char** src,const char* end, const char* value, const char* exit)
{
	while (*src != end) {
		switch ( *(*src) ) {
		case S_CBEGIN:
			if (smv_getvar(&(*dest), &(++(*src))))
				return true;
			continue;
		case S_CVALUE:
			while (*value) *(*dest)++ = *value++;
			(*src)++;
			continue;
		case S_CEXIT:
			*src = exit;
			return true;
		}
		*(*dest)++ = *(*src)++;
	}
	*src = exit;
	return false;
}

// does operations in { }, returns true if we have skip char ( # )
bool smv_getvar(char** dest, const char** src)
{
	static char name[6][32]; 
	static char value[6][128];
	static int i = -1;
	if ( ++i == 6 ) { --i; return true; }
	char* n = name[i]; *n = 0;
	char* v = value[i]; *v = 0;
	// jump into proper situation in { }
	const char* code = *src;
	const char* r;
	*src+=6;
	switch (*code){
	case 1: // this is an normal { x }
		if (smv_getans(&n, &(*src), (*src + *(code+2) - 1) )){ --i; return true;}
		r = smv_gamevar(name[i]);
		while ( *r ) *(*dest)++ = *r++;
	break;
	case 7: // { %.b + c }
		if (smv_getans(&n, &(*src), (*src + *(code+2) - 1) )){ --i; return true; }
		if (smv_getans(&v, &(*src), (*src + *(code+3) - 1) )){ --i; return true; }
		doVar(&sm_var, name[i]+2 ,*(code+1), value[i], *(code+3) - 1 );
	break;
	case 9: // { a ? d }
		if (smv_getans(&n, &(*src), (*src + *(code+2) - 1) )){ --i; return true; }
		r = smv_gamevar(name[i]);
		if (smv_cond(r,*(code+1),value[i])){
			if (smv_setarg(&(*dest), &(*src), (*src + *(code+4) - 1),r, (*src + *(code+4) - 1)))
				{ --i; return true; }
		}
		else {
			*src += (*(code+4) - 1);
		}
	break;
	case 25: // { a ? d : e }
		if (smv_getans(&n, &(*src), (*src + *(code+2)  - 1) )){ --i; return true; }
		r = smv_gamevar(name[i]);
		if (smv_cond(r,*(code+1),value[i])){
			if (smv_setarg(&(*dest), &(*src), (*src + *(code+4) - 1),r, (*src + *(code+4) + *(code+5) - 2)))
				{ --i; return true; }
		}
		else {
			*src += (*(code+4) - 1);
			if (smv_setarg(&(*dest), &(*src), (*src + *(code+5) - 1),r, (*src + *(code+5) - 1)))
				{ --i; return true; }
		}
	break;
	case 13: // { a = c ? d }
		if (smv_getans(&n, &(*src), (*src + *(code+2) - 1) )){ --i; return true; }
		if (smv_getans(&v, &(*src), (*src + *(code+3) - 1) )){ --i; return true; }
		r = smv_gamevar(name[i]);
		if (smv_cond(r,*(code+1),value[i])){
			if (smv_setarg(&(*dest), &(*src), (*src + *(code+4) - 1),r, (*src + *(code+4) - 1)))
				{ --i; return true; }
		}
		else {
			*src += (*(code+4) - 1);
		}

	break;
	case 29: // { a = c ? d : e }
		if (smv_getans(&n, &(*src), (*src + *(code+2) - 1) )){ --i; return true; }
		if (smv_getans(&v, &(*src), (*src + *(code+3) - 1) )){ --i; return true; }
		r = smv_gamevar(name[i]);
		if (smv_cond(r,*(code+1),value[i])){
			if (smv_setarg(&(*dest), &(*src), (*src + *(code+4) - 1),r, (*src + *(code+4) + *(code+5) - 2)))
				{ --i; return true; }
		}
		else {
			*src += (*(code+4) - 1);
			if (smv_setarg(&(*dest), &(*src), (*src + *(code+5) - 1),r, (*src + *(code+5) - 1)))
				{ --i; return true; }
		}
	break;
	case 5: // { a + c }
		if (smv_getans(&n, &(*src), (*src + *(code+2) - 1) )){ --i; return true;}
		if (smv_getans(&v, &(*src), (*src + *(code+3) - 1) )){ --i; return true;}
		r = smv_gamevar(name[i]);
		doCalc(&(*dest), r, *(code+1), value[i]);
	break;
	case 37: // { #.a = c }
		if (smv_getans(&n, &(*src), (*src + *(code+2) - 1) )){ --i; return true; }
		v = value[i];
		r = v + *(code+3) - 1;
		while (v != r) *v++ = *(*src)++; *v = 0;
		doVar(&sm_var,  name[i]+2 ,S_CEQUAL, value[i], *(code+3) - 1 );
	break;
	case 97: // { #.a }
		if (smv_getans(&n, &(*src), (*src + *(code+2) - 1) )){ --i; return true; }
		r = smv_gamevar(name[i]);
		while ( *r ) {
			if ( *r == S_CBEGIN ) {
				if (smv_getvar(&(*dest), &(++r))){ --i; return true; }
				continue;
			}
			*(*dest)++ = *r++;
		}
	break;
	}
	*(*src)++;
	--i;
	return false;
}

// copy the context with filling the values if needed
char* smv_putvars(register const char* src)
{
	static char szMsg[3][512];
	static int i = -1;
	if ( ++i == 3) { *szMsg[i] = 0; return szMsg[i--]; }
	register char* dest = szMsg[i];
	while ( *src ) {
		if ( *src == S_CBEGIN ) {
			if (smv_getvar(&dest, &(++src))){	*szMsg[i] = 0;	return szMsg[i--];	}
			continue;
		}
		*dest++ = *src++;
	}
	if ( dest != szMsg[i] )	*dest++ = '\n';
	*dest = 0;
	return szMsg[i--];
}
